//
//    0@ L 22
//
//  2005/ 1/ 7 ˁ@P
//

#include "classes.h"
#include <commctrl.h>
#include <stdio.h>
#include "afxres.h"
#include <math.h>
#include <stdlib.h>
#include <time.h>

HINSTANCE hInst;

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK BMPWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ResizeDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ConvDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK RGBDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK UnsharpDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ContDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ContSDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK FogDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK TrimDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ExPixelDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK GammaDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK PostDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK OutlineDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK AaliaDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK YCutDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ReplaceDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK RGBDefDialogProc(HWND, UINT, WPARAM, LPARAM);

FILTER9INFO FilterDialog();
bool resize();
bool conv();
RGBINFO RGBDialog();
bool unsharp();
bool cont();
bool contS();
bool fog();
bool trim();
bool exPixel();
bool gamma();
bool post();
bool outline();
bool aalia();
bool ycut();
bool replace();
bool rgbdef();

HWND hwMain, hwBMP, hwState, hwFil9Dialog[13], hwResizeDialog[6];
HWND hwRGBDialog[15], hwContDialog[6], hwTrimDialog[6];
HMENU hMenu, hMenuFile, hMenuInfo, hMenuEdit, hMenuDef, hMenuConv, hMenuTrans;
HMENU hMenuFilt, hMenuHelp, hMenuVSize, hMenuQU;
DWORD dwWidth, dwHeight, dwVWidth, dwVHeight, dwVSizeW, dwVSizeH, dwJQU = 90;
int iLX1 =- 1, iLY1, iLX2, iLY2;
double lfVSize = 1.0;
bool fTrim = FALSE, fUndo = FALSE, fSave = FALSE; 
TCHAR lpszAppName[] = "L";
TCHAR lpszFileName[MAX_PATH + 1], lpszTitle[MAX_PATH + 32];
SBMAgent saAgent;
SDIB32 *sbBM, *sbBack;

#define IDM_OPEN    101
#define IDM_SAVE    102
#define IDM_WRITE   103
#define IDM_EXIT    104
#define IDM_UNDO    201
#define IDM_COPY    202
#define IDM_PASTE   203
#define IDM_TRIM    204
#define IDM_SIZE025 301
#define IDM_SIZE05  302
#define IDM_SIZE1   303
#define IDM_SIZE2   304
#define IDM_SIZE3   305
#define IDM_SIZE4   306
#define IDM_QU100   307
#define IDM_QU90    308
#define IDM_QU80    309
#define IDM_QU70    310
#define IDM_QU60    311
#define IDM_QU50    312
#define IDM_SIZE    401
#define IDM_COLORS  402
#define IDM_RESIZE  501
#define IDM_CONV    502
#define IDM_CONT    503
#define IDM_CONTS   504
#define IDM_GAMMA   505
#define IDM_CONTA   506
#define IDM_POST    507
#define IDM_YCUT    508
#define IDM_GRAY    601
#define IDM_XOR     602
#define IDM_RGB     603
#define IDM_UPSET   604
#define IDM_MIRROR  605
#define IDM_EXXY    606
#define IDM_EXPIX   607
#define IDM_REPLACE 608
#define IDM_T216    609
#define IDM_ENB     701
#define IDM_CFILTER 702
#define IDM_UNSHARP 703
#define IDM_FOG     704
#define IDM_MED     705
#define IDM_OUTLINE 706
#define IDM_AALIA   707
#define IDM_RGBDEF  708
#define IDM_ABOUT   801
#define IDM_JUMP    802

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow){

	MSG  msg;
	WNDCLASSEX wndclass, diaclass;

	hInst=hInstance; // vZX̃nhۑ
	srand((unsigned)time(NULL)); // 񏉊

	sbBM=new SDIB32();
	sbBack=new SDIB32();

	// EChENXݒ
	wndclass.cbSize        = sizeof(wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(hInstance,"APP_ICON");
	wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "CWindow";
	wndclass.hIconSm       = LoadIcon(hInstance,"APP_ICON");

	RegisterClassEx(&wndclass); // EChENXo^

	diaclass.cbSize        = sizeof(diaclass);
	diaclass.style         = CS_HREDRAW | CS_VREDRAW;
	diaclass.lpfnWndProc   = DialogProc;
	diaclass.cbClsExtra    = 0;
	diaclass.cbWndExtra    = 0;
	diaclass.hInstance     = hInstance;
	diaclass.hIcon         = NULL;
	diaclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
	diaclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	diaclass.lpszMenuName  = NULL;
	diaclass.lpszClassName = "CDialog";
	diaclass.hIconSm       = NULL;

	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = ResizeDialogProc;
	diaclass.lpszClassName = "CResizeDialog";

	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = ConvDialogProc;
	diaclass.lpszClassName = "CConvDialog";

	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = RGBDialogProc;
	diaclass.lpszClassName = "CRGBDialog";

	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = UnsharpDialogProc;
	diaclass.lpszClassName = "CUnsharpDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = ContDialogProc;
	diaclass.lpszClassName = "CContDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = ContSDialogProc;
	diaclass.lpszClassName = "CContSDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = FogDialogProc;
	diaclass.lpszClassName = "CFogDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = TrimDialogProc;
	diaclass.lpszClassName = "CTrimDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = ExPixelDialogProc;
	diaclass.lpszClassName = "CExPixelDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = GammaDialogProc;
	diaclass.lpszClassName = "CGammaDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = PostDialogProc;
	diaclass.lpszClassName = "CPostDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = OutlineDialogProc;
	diaclass.lpszClassName = "COutlineDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = AaliaDialogProc;
	diaclass.lpszClassName = "CAaliaDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = YCutDialogProc;
	diaclass.lpszClassName = "CYCutDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = ReplaceDialogProc;
	diaclass.lpszClassName = "CReplaceDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	diaclass.lpfnWndProc   = RGBDefDialogProc;
	diaclass.lpszClassName = "CRGBDefDialog";
	RegisterClassEx(&diaclass); /* EChENXo^ */

	if (lstrcmpi(szCmdLine, "") != 0) {

		/* t@C̑O""΍폜 */
		if (szCmdLine[0]=='"') {
			wsprintf(szCmdLine,"%s",szCmdLine+1);
		}

		if (szCmdLine[lstrlen(szCmdLine)-1]=='"') {
			szCmdLine[lstrlen(szCmdLine)-1]=0;
		}

		if (saAgent.loadFile(sbBM,szCmdLine)) {
			lstrcpy(lpszFileName,szCmdLine);
		}

	} else {
		lpszFileName[0]=0;
	}

	dwVSizeW = (DWORD)(sbBM->getWidth() * lfVSize);
	dwVSizeH = (DWORD)(sbBM->getHeight() * lfVSize);

	hwMain = CreateWindow("CWindow", lpszAppName,
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT,
	  600, 450, NULL, NULL, hInstance, NULL);

	if (lpszFileName[0] != 0) { // 摜t@Cǂݍ܂Ă

		if (stricmp(lpszFileName+(strlen(lpszFileName)-4),".wmf")==0) {

			lstrcpy(lpszFileName, "");

			wsprintf(lpszTitle, "%s - %s", lpszAppName, lpszFileName);
			SetWindowText(hwMain, lpszTitle);

		} else {

			wsprintf(lpszTitle, "%s - %s", lpszAppName, lpszFileName);
			SetWindowText(hwMain, lpszTitle);

		}

	}

	// j[쐬
	hMenu = CreateMenu();      // gbvx
	hMenuFile = CreateMenu();  // ut@Cvj[
	hMenuEdit = CreateMenu();  // uҏWvj[
	hMenuDef = CreateMenu();   // uݒvj[
	hMenuInfo = CreateMenu();  // u摜vj[
	hMenuConv = CreateMenu();  // uvj[
	hMenuTrans = CreateMenu(); // uϊvj[
	hMenuFilt = CreateMenu();  // utB^vj[
	hMenuHelp = CreateMenu();  // uwvvj[

    // ut@Cvj[ڍ쐬
	AppendMenu(hMenuFile, MF_STRING,IDM_OPEN, "Ji&Oj");
	AppendMenu(hMenuFile, MF_STRING,IDM_SAVE, "ۑi&Aj");
	AppendMenu(hMenuFile, MF_STRING,IDM_WRITE, "㏑ۑi&Sj");
	AppendMenu(hMenuFile, MF_SEPARATOR, 0, NULL);
	AppendMenu(hMenuFile, MF_STRING,IDM_EXIT, "Ii&Xj");

	// u摜vj[ڍ쐬
	AppendMenu(hMenuInfo, MF_STRING, IDM_SIZE, "傫i&Sj");
	AppendMenu(hMenuInfo, MF_STRING, IDM_COLORS, "Fi&Cj");

	// uҏWvj[ڍ쐬
	AppendMenu(hMenuEdit, MF_STRING, IDM_UNDO, "ɖ߂(&U)");
	AppendMenu(hMenuEdit, MF_STRING, IDM_COPY, "rbg}bvRs[(&C)");
	AppendMenu(hMenuEdit, MF_STRING, IDM_PASTE, "rbg}bv\t(&P)");
	AppendMenu(hMenuEdit, MF_STRING, IDM_TRIM, "g~O(&T)");

	// uݒvj[ڍ쐬
	hMenuVSize = CreateMenu(); // u\TCYvj[
	AppendMenu(hMenuVSize, MF_STRING, IDM_SIZE025, "0.25{(&0)");
	AppendMenu(hMenuVSize, MF_STRING, IDM_SIZE05, "0.5{(&1)");
	AppendMenu(hMenuVSize, MF_STRING, IDM_SIZE1, "(&2)");
	AppendMenu(hMenuVSize, MF_STRING, IDM_SIZE2, "Q{(&3)");
	AppendMenu(hMenuVSize, MF_STRING, IDM_SIZE3, "R{(&4)");
	AppendMenu(hMenuVSize, MF_STRING, IDM_SIZE4, "S{(&5)");
	AppendMenu(hMenuDef, MF_POPUP, (UINT)hMenuVSize, "\TCYi&Vj");
	hMenuQU = CreateMenu(); // uJpegۑivj[
	AppendMenu(hMenuQU, MF_STRING, IDM_QU100, "100(&A)");
	AppendMenu(hMenuQU, MF_STRING, IDM_QU90, "90(&9)");
	AppendMenu(hMenuQU, MF_STRING, IDM_QU80, "80(&8)");
	AppendMenu(hMenuQU, MF_STRING, IDM_QU70, "70(&7)");
	AppendMenu(hMenuQU, MF_STRING, IDM_QU60, "60(&6)");
	AppendMenu(hMenuQU, MF_STRING, IDM_QU50, "50(&5)");
	AppendMenu(hMenuDef, MF_POPUP, (UINT)hMenuQU, "Jpegۑii&Qj");

	// j[ڍ쐬
	AppendMenu(hMenuConv, MF_STRING, IDM_RESIZE,"TCYi&Rj");
	AppendMenu(hMenuConv, MF_STRING, IDM_CONV, "i&Cj");
	AppendMenu(hMenuConv, MF_STRING, IDM_CONT, "xRgXgi&Yj");
	AppendMenu(hMenuConv, MF_STRING, IDM_CONTS, "ʓxi&Sj");
	AppendMenu(hMenuConv, MF_STRING, IDM_GAMMA, "K}␳i&Gj");
	AppendMenu(hMenuConv, MF_STRING, IDM_CONTA, "RgXgő剻i&Mj");
	AppendMenu(hMenuConv, MF_STRING, IDM_POST, "KύXi&Pj");
	AppendMenu(hMenuConv, MF_STRING, IDM_YCUT, "K؎̂āi&Vj");

	// ϊj[ڍ쐬
	AppendMenu(hMenuTrans, MF_STRING, IDM_GRAY, "i&Gj");
	AppendMenu(hMenuTrans, MF_STRING, IDM_XOR, "F]i&Xj");
	AppendMenu(hMenuTrans, MF_STRING, IDM_RGB, "RGBϊi&Bj");
	AppendMenu(hMenuTrans, MF_STRING, IDM_UPSET, "㉺]i&Uj");
	AppendMenu(hMenuTrans, MF_STRING, IDM_MIRROR, "E]i&Mj");
	AppendMenu(hMenuTrans, MF_STRING, IDM_EXXY, "XYi&Ej");
	AppendMenu(hMenuTrans, MF_STRING, IDM_EXPIX, "sNZi&Pj");
	AppendMenu(hMenuTrans, MF_STRING, IDM_REPLACE, "PFui&Rj");
	AppendMenu(hMenuTrans, MF_STRING, IDM_T216, "216Fi&Tj");

	// tB^j[ڍ쐬
	AppendMenu(hMenuFilt, MF_STRING, IDM_ENB, "G{Xi&Ej");
	AppendMenu(hMenuFilt, MF_STRING, IDM_CFILTER, "JX^tB^i&Cj");
	AppendMenu(hMenuFilt, MF_STRING, IDM_UNSHARP, "AV[v}XNi&Uj");
	AppendMenu(hMenuFilt, MF_STRING, IDM_FOG, "ڂi&Fj");
	AppendMenu(hMenuFilt, MF_STRING, IDM_MED, "fBAtB^i&Mj");
	AppendMenu(hMenuFilt, MF_STRING, IDM_OUTLINE, "֊sǉi&Oj");
	AppendMenu(hMenuFilt, MF_STRING, IDM_AALIA, "A`GCAVOi&Aj");
	AppendMenu(hMenuFilt, MF_STRING, IDM_RGBDEF, "Fgi&Aj");

	// wvj[ڍ쐬
	AppendMenu(hMenuHelp, MF_STRING, IDM_ABOUT, "o[Wi&Aj");
	AppendMenu(hMenuHelp, MF_STRING, IDM_JUMP, "҃TCgunvO~O̊Xvցi&Gj");

	// gbvxj[ɒǉ
	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuFile, "t@Ci&Fj");
	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuEdit, "ҏWi&Ej");
	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuDef, "ݒi&Dj");
	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuInfo, "摜i&Ij");
	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuConv, "i&Cj");
	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuTrans, "ϊi&Tj");
	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuFilt, "tB^i&Lj");
	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuHelp, "wvi&Hj");

	CheckMenuRadioItem(hMenuVSize, IDM_SIZE05, IDM_SIZE2, IDM_SIZE1, MF_BYCOMMAND);
	CheckMenuRadioItem(hMenuQU, IDM_QU100, IDM_QU50, IDM_QU90, MF_BYCOMMAND);

	// EChEɃj[ݒ
	SetMenu(hwMain, hMenu);

	while (GetMessage(&msg, NULL, 0, 0)) { /* bZ[W[v */

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	return msg.wParam;

}

// CEChEEChEvV[W|
LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	static OPENFILENAME ofn;
	static char lpszFn[256], lpszFt[256], lpszWrk[256];
	static PCHAR lpszOpen = "J", lpszSave = "ۑ";
	HDROP hDrop;
	static WNDCLASSEX wndclass;
	FILTER9INFO f9Info;
	RGBINFO rInfo;
	double lfMatrix[9] = {0, 0, 1, 0, 0, 0, -1, 0, 0};
	int i, j;
	static int iVSize;
	RECT rec;
	WIN32_FIND_DATA fd;
	HANDLE fh;
	DWORD dwMin, dwMax;
	
	switch (iMsg) {

	case WM_CREATE:

		// OPENFILENAME\̏
		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hwndOwner = hwMain;
		ofn.hInstance = hInst;
		ofn.lpstrFilter = "rbg}bv(*.bmp)\0*.bmp\0Jpegt@C(*.jpg)\0*.jpg\0YCrCbt@C(*.ycc)\0*.ycc\0ׂẴt@C(*.*)\0*.*\0\0";
		ofn.lpstrCustomFilter = NULL;
		ofn.nMaxCustFilter = 0;
		ofn.nFilterIndex = 1;
		ofn.lpstrFile = lpszFn;
		ofn.nMaxFile = 255;
		ofn.lpstrFileTitle = lpszFt;
		ofn.nMaxFileTitle = 255;
		ofn.lpstrInitialDir = NULL;
		ofn.lpstrTitle = NULL;
		ofn.Flags = 0;
		ofn.nFileOffset = 0;
		ofn.nFileExtension = 0;
		ofn.lpstrDefExt = NULL;
		ofn.lCustData = 0;
		ofn.lpfnHook = NULL;
		ofn.lpTemplateName = NULL;

		DragAcceptFiles(hwnd, TRUE); // hbOhbv

		wndclass.cbSize        = sizeof(wndclass);
		wndclass.style         = CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc   = BMPWndProc;
		wndclass.cbClsExtra    = 0;
		wndclass.cbWndExtra    = 0;
		wndclass.hInstance     = hInst;
		wndclass.hIcon         = NULL;
		wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
		wndclass.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
		wndclass.lpszMenuName  = NULL;
		wndclass.lpszClassName = "CBMPWin";
		wndclass.hIconSm       = NULL;

		RegisterClassEx(&wndclass); // EChENXo^

		hwBMP=CreateWindow("CBMPWin", NULL, WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL,
		  0, 0, 1, 1, hwnd, NULL, hInst, NULL);

		hwState = CreateStatusWindow(WS_CHILD | WS_VISIBLE, NULL, hwnd, 0);

		return 0;

	case WM_DROPFILES:

		hDrop = (HDROP)wParam;

		DragQueryFile(hDrop, 0, lpszWrk, 256);

		if (saAgent.loadFile(sbBM, lpszWrk)) { // t@Cǂݍ

			fUndo = FALSE;
			fSave = FALSE;
			*sbBack = *sbBM;

			if (stricmp(lpszWrk+(strlen(lpszWrk)-4),".wmf")==0) {
			
				lstrcpy(lpszFileName, "");
				lstrcpy(lpszFn, "");

			} else {

				lstrcpy(lpszFileName, lpszWrk);
				lstrcpy(lpszFn, lpszWrk);

			}

			wsprintf(lpszTitle, "%s - %s", lpszAppName, lpszFileName);
			SetWindowText(hwMain, lpszTitle);

		}

		DragFinish(hDrop);

		dwVSizeW = (DWORD)(sbBM->getWidth() * lfVSize);
		dwVSizeH = (DWORD)(sbBM->getHeight() * lfVSize);
		MoveWindow(hwBMP, 0, 0, dwVWidth - 1, dwVHeight - 1, FALSE);
		MoveWindow(hwBMP, 0, 0, dwVWidth, dwVHeight, TRUE);
		InvalidateRgn(hwnd, NULL, FALSE);
		UpdateWindow(hwnd);

		break;

	case WM_INITMENUPOPUP:

		if (lParam == 0 && fSave) {
			EnableMenuItem((HMENU)wParam, IDM_WRITE, MF_ENABLED);
		} else {
			EnableMenuItem((HMENU)wParam, IDM_WRITE, MF_GRAYED);
		}

		if (lParam == 1 && IsClipboardFormatAvailable(CF_DIB)) {
			EnableMenuItem((HMENU)wParam, IDM_PASTE, MF_ENABLED);
		} else {
			EnableMenuItem((HMENU)wParam, IDM_PASTE, MF_GRAYED);
		}

		if (lParam == 1 && fUndo) {
			EnableMenuItem((HMENU)wParam, IDM_UNDO, MF_ENABLED);
		} else {
			EnableMenuItem((HMENU)wParam, IDM_UNDO, MF_GRAYED);
		}

		break;

	case WM_COMMAND:

		switch (LOWORD(wParam)) {

		case IDM_OPEN: // Jj[

			// _CAOݒ
			ofn.lpstrTitle=lpszOpen;
			ofn.Flags=OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
			ofn.nFilterIndex=1;

			if (!GetOpenFileName(&ofn)) // t@CI
				return 0;

			if (saAgent.loadFile(sbBM,lpszFn)) { // t@Cǂݍ

				fUndo=FALSE;
				fSave=FALSE;
				*sbBack=*sbBM;

				if (stricmp(lpszFn+(strlen(lpszFn)-4),".wmf")==0) {

					lstrcpy(lpszFileName,"");
					wsprintf(lpszTitle,"%s - %s",lpszAppName,lpszFileName);
					SetWindowText(hwMain,lpszTitle);

				} else {

					lstrcpy(lpszFileName,lpszFn);
					wsprintf(lpszTitle,"%s - %s",lpszAppName,lpszFileName);
					SetWindowText(hwMain,lpszTitle);

				}

			}

			MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
			MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);
			dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
			dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);
			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_SAVE: // ۑj[

			// _CAOݒ
			ofn.lpstrTitle=lpszSave;
			ofn.Flags=OFN_HIDEREADONLY;

			if (stricmp(lpszFn+(strlen(lpszFn)-4),".jpg")==0)
				ofn.nFilterIndex=2;
			else
				ofn.nFilterIndex=1;

			if (!GetSaveFileName(&ofn)) // t@CI
				return 0;

			if (ofn.nFilterIndex==1 && stricmp(lpszFn+(strlen(lpszFn)-4),".bmp")!=0)
				lstrcat(lpszFn,".bmp");
			else if (ofn.nFilterIndex==2 && stricmp(lpszFn+(strlen(lpszFn)-4),".jpg")!=0)
				lstrcat(lpszFn,".jpg");
			else if (ofn.nFilterIndex==3 && stricmp(lpszFn+(strlen(lpszFn)-4),".ycc")!=0)
				lstrcat(lpszFn,".ycc");

			fh=FindFirstFile(lpszFn,&fd);

			if (fh!=INVALID_HANDLE_VALUE && MessageBox(hwnd,
			  "̃t@Cɑ݂܂B㏑܂H",
			  lpszFn,MB_OKCANCEL)!=IDOK) {

				FindClose(fh);
				break;

			}

			FindClose(fh);
				
			if ((ofn.nFilterIndex==3) && (MessageBox(hwnd,
			  "YCrCb`ŕۑƏ̈ꕔ\܂BYCrCb`ŕۑ܂H",
			  lpszFn,MB_OKCANCEL)!=IDOK))
				break;

			if (saAgent.saveFile(sbBM,lpszFn,dwJQU)) { // t@Cɕۑ

				fSave=FALSE;

				lstrcpy(lpszFileName,lpszFn);
				wsprintf(lpszTitle,"%s - %s",lpszAppName,lpszFileName);
				SetWindowText(hwMain,lpszTitle);

			}

			break;

		case IDM_WRITE: // ㏑ۑj[

			if (lpszFileName[0]!=0) {

				if (saAgent.saveFile(sbBM,lpszFileName,dwJQU))
					fSave=FALSE;
				else
					MessageBox(hwnd,"ۑɎs܂B","G[",MB_OK);

				break;

			}

			// _CAOݒ
			ofn.lpstrTitle=lpszSave;
			ofn.Flags=OFN_HIDEREADONLY;
			ofn.nFilterIndex=1;

			if (!GetSaveFileName(&ofn)) // t@CI
				return 0;

			if (ofn.nFilterIndex==1 && stricmp(lpszFn+(strlen(lpszFn)-4),".bmp")!=0)
				lstrcat(lpszFn,".bmp");
			else if (ofn.nFilterIndex==2 && stricmp(lpszFn+(strlen(lpszFn)-4),".jpg")!=0)
				lstrcat(lpszFn,".jpg");

			fh=FindFirstFile(lpszFn,&fd);

			if (fh!=INVALID_HANDLE_VALUE && MessageBox(hwnd,"̃t@Cɑ݂܂B㏑܂H",
			    lpszFn,MB_OKCANCEL)!=IDOK)
				break;

			FindClose(fh);

			if (saAgent.saveFile(sbBM,lpszFn,dwJQU)) { // t@Cɕۑ

				fSave=FALSE;

				lstrcpy(lpszFileName,lpszFn);
				wsprintf(lpszTitle,"%s - %s",lpszAppName,lpszFileName);
				SetWindowText(hwMain,lpszTitle);

			}

			break;

		case IDM_EXIT: // Ij[

			DestroyWindow(hwMain);

			break;

		case IDM_SIZE:

			wsprintf(lpszWrk,":%dsNZ :%dsNZ",
			  sbBM->getWidth(),sbBM->getHeight());

			MessageBox(hwnd,lpszWrk,"摜TCY",MB_OK);

			break;

		case IDM_COLORS:

			wsprintf(lpszWrk,"F:%dF",sbBM->getColors());

			MessageBox(hwnd,lpszWrk,"摜F",MB_OK);

			break;

		case IDM_UNDO: // ɖ߂

			if (fUndo) {

				*sbBM=*sbBack;
				fUndo=FALSE;

				dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
				dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);
				MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
				MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);

				InvalidateRgn(hwnd,NULL,FALSE);
				UpdateWindow (hwnd);

			}

			break;

		case IDM_COPY: // Rs[

			saAgent.copy(sbBM);

			break;

		case IDM_PASTE: // \t

			if (saAgent.paste(sbBM)) {

				fUndo=FALSE;

				lpszFileName[0]=0;
				wsprintf(lpszTitle,"%s - %s",lpszAppName,lpszFileName);
				SetWindowText(hwMain,lpszTitle);

			}

			dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
			dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);
			MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight-1,FALSE);
			MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_TRIM: // g

			if (trim()) {

				fUndo=TRUE;
				fSave=TRUE;

				MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
				MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);

				dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
				dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);
				MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
				MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_SIZE025: // \{0.25{

			lfVSize=0.25;

			CheckMenuRadioItem(hMenuVSize,IDM_SIZE025,IDM_SIZE4,IDM_SIZE025,MF_BYCOMMAND);

			dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
			dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);

			MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
			MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);
			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_SIZE05: // \{0.5{

			lfVSize=0.5;

			CheckMenuRadioItem(hMenuVSize,IDM_SIZE025,IDM_SIZE4,IDM_SIZE05,MF_BYCOMMAND);

			dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
			dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);

			MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
			MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);
			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_SIZE1: // \{1{

			lfVSize=1.0;

			CheckMenuRadioItem(hMenuVSize,IDM_SIZE025,IDM_SIZE4,IDM_SIZE1,MF_BYCOMMAND);

			dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
			dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);

			MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
			MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);
			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_SIZE2: // \{2{

			lfVSize=2.0;

			CheckMenuRadioItem(hMenuVSize,IDM_SIZE025,IDM_SIZE4,IDM_SIZE2,MF_BYCOMMAND);

			dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
			dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);

			MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
			MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);
			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_SIZE3: // \{3{

			lfVSize=3.0;

			CheckMenuRadioItem(hMenuVSize,IDM_SIZE025,IDM_SIZE4,IDM_SIZE3,MF_BYCOMMAND);

			dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
			dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);

			MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
			MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);
			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_SIZE4: // \{4{

			lfVSize=4.0;

			CheckMenuRadioItem(hMenuVSize,IDM_SIZE025,IDM_SIZE4,IDM_SIZE4,MF_BYCOMMAND);

			dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
			dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);

			MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
			MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);
			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_QU100:

			if (dwJQU!=100)
				fSave=true;

			dwJQU=100;

			CheckMenuRadioItem(hMenuQU,IDM_QU100,IDM_QU50,IDM_QU100,MF_BYCOMMAND);

			break;

		case IDM_QU90:

			if (dwJQU!=90)
				fSave=true;

			dwJQU=90;

			CheckMenuRadioItem(hMenuQU,IDM_QU100,IDM_QU50,IDM_QU90,MF_BYCOMMAND);

			break;

		case IDM_QU80:

			if (dwJQU!=80)
				fSave=true;

			dwJQU=80;

			CheckMenuRadioItem(hMenuQU,IDM_QU100,IDM_QU50,IDM_QU80,MF_BYCOMMAND);

			break;

		case IDM_QU70:

			if (dwJQU!=70)
				fSave=true;

			dwJQU=70;

			CheckMenuRadioItem(hMenuQU,IDM_QU100,IDM_QU50,IDM_QU70,MF_BYCOMMAND);

			break;

		case IDM_QU60:

			if (dwJQU!=60)
				fSave=true;

			dwJQU=60;

			CheckMenuRadioItem(hMenuQU,IDM_QU100,IDM_QU50,IDM_QU60,MF_BYCOMMAND);

			break;

		case IDM_QU50:

			if (dwJQU!=50)
				fSave=true;

			dwJQU=50;

			CheckMenuRadioItem(hMenuQU,IDM_QU100,IDM_QU50,IDM_QU50,MF_BYCOMMAND);

			break;

		case IDM_GRAY: // 

			*sbBack=*sbBM;
			saAgent.toGray(sbBM); // 

			fUndo=TRUE;
			fSave=TRUE;

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_RESIZE: // TCY

			if (resize()) {

				fUndo=TRUE;
				fSave=TRUE;

				MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
				MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);

				dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
				dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);
				MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
				MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);
				InvalidateRgn(hwnd,NULL,FALSE);
				UpdateWindow (hwnd);

			}

			break;

		case IDM_CONV: // 

			if (conv()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_XOR: // F]

			*sbBack=*sbBM;
			fUndo=TRUE;
			fSave=TRUE;

			saAgent.xorRGB(sbBM);

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_RGB: // RGBϊ

			rInfo=RGBDialog();

			if (rInfo.dwFlg==1) {

				*sbBack=*sbBM;
				fUndo=TRUE;
				fSave=TRUE;

				saAgent.calcRGB(sbBM,&rInfo);

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_CONT:

			if (cont()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_CONTS:

			if (contS()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_GAMMA: // K}␳

			if (gamma()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_CONTA: // RgXgő剻

			dwMin=255;
			dwMax=0;

			for (i=0;i<sbBM->getHeight();i++)
				for (j=0;j<sbBM->getWidth();j++) {

					if (sbBM->getY(j,i)<dwMin)
						dwMin=sbBM->getY(j,i);

					if (sbBM->getY(j,i)>dwMax)
						dwMax=sbBM->getY(j,i);

				}

			*sbBack=*sbBM;
			saAgent.contY(sbBM,dwMin,dwMax,0,255); // RgXgő剻

			fUndo=TRUE;
			fSave=TRUE;

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_POST: // KύX

			if (post()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_YCUT: // K؎̂

			if (ycut()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_UPSET: // ㉺]

			*sbBack=*sbBM;
			saAgent.upset(sbBM); // 

			fUndo=TRUE;
			fSave=TRUE;

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_MIRROR: // E]

			*sbBack=*sbBM;
			saAgent.mirror(sbBM); // 

			fUndo=TRUE;
			fSave=TRUE;

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_EXXY: // XY

			*sbBack=*sbBM;
			saAgent.exchangeXY(sbBM); // XY

			fUndo=TRUE;
			fSave=TRUE;

			dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
			dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);
			MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
			MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);
			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_EXPIX: // sNZ

			if (exPixel()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_REPLACE: // PFu

			if (replace()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_T216: // 216F

			*sbBack = *sbBM;
			saAgent.t216(sbBM);

			fUndo=TRUE;
			fSave=TRUE;

			dwVSizeW=(DWORD)(sbBM->getWidth()*lfVSize);
			dwVSizeH=(DWORD)(sbBM->getHeight()*lfVSize);
			MoveWindow(hwBMP,0,0,dwVWidth-1,dwVHeight,FALSE);
			MoveWindow(hwBMP,0,0,dwVWidth,dwVHeight,TRUE);

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;


			break;

		case IDM_ENB: // G{X

			*sbBack=*sbBM;
			fUndo=TRUE;
			fSave=TRUE;

			saAgent.toGray(sbBM); // 

			for (i=0;i<9;i++)
				f9Info.lfMatrix[i]=lfMatrix[i];

			f9Info.lfAdd=128;
			f9Info.lfDiv=1;

			saAgent.Filter9(sbBM,&f9Info);

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_CFILTER: // JX^tB^

			f9Info=FilterDialog();

			if (f9Info.lfDiv==0 || f9Info.lfDiv>999)
				break;

			*sbBack=*sbBM;
			fUndo=TRUE;
			fSave=TRUE;

			saAgent.Filter9(sbBM,&f9Info);

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_UNSHARP: // AV[v}XN

			if (unsharp()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_FOG: // ڂ

			if (fog()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_MED: // fBAtB^

			*sbBack=*sbBM;
			sbBM->median(); // 

			fUndo=TRUE;
			fSave=TRUE;

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_OUTLINE: // ֊sǉ

			if (outline()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_AALIA: // A`GCAVO

			if (aalia()) {

				fUndo=TRUE;
				fSave=TRUE;

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_RGBDEF: // Fg

			if (rgbdef()) {

				fUndo = true;
				fSave = true;

			}

			InvalidateRgn(hwnd, NULL, FALSE);
			UpdateWindow (hwnd);

			break;

		case IDM_ABOUT: // o[W

			MessageBox(hwnd,"0@ L 22 (C)2000-2005 ˁ@P","o[W",MB_OK);

			break;

		case IDM_JUMP: // nvO~O̊X

			ShellExecute(NULL,"open","http://www.sm.rim.or.jp/~shishido/", 
			  NULL,NULL,SW_SHOWNORMAL);

			break;

		}
	
		return 0;

	case WM_SIZE:

		SendMessage(hwState,WM_SIZE,LOWORD(lParam),0);

		GetWindowRect(hwState,&rec);

		dwVWidth=LOWORD(lParam);
		dwVHeight=HIWORD(lParam)-(rec.bottom-rec.top);

		SetWindowPos(hwBMP,hwnd,0,0,dwVWidth,dwVHeight,SWP_NOZORDER);

		return 0;

	case WM_DESTROY : // I

		delete sbBM,sbBack;

		PostQuitMessage(0);

		return 0;

	}

	return DefWindowProc(hwnd,iMsg,wParam,lParam) ;

}

// DIBEChEEChEvV[W[
LRESULT CALLBACK BMPWndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	static SCROLLINFO sInfo;
	static int iVSMin,iVSMax,iVSPage,iHSMin,iHSMax,iHSPage,iVSd,iVSPos,iHSd,iHSPos;
	int iPosX,iPosY,iR,iG,iB;
	HDC hdc;
	PAINTSTRUCT ps;
	char tmp[64];
	static HPEN pen1,pen2;

	switch (iMsg) {

	case WM_CREATE:

		pen1=CreatePen(PS_SOLID,1,RGB(192,0,0));
		pen2=CreatePen(PS_DOT,1,RGB(192,192,192));

		break;

	case WM_SIZE: // EChETCYύX

		sInfo.cbSize=sizeof(SCROLLINFO);
		sInfo.fMask=SIF_ALL;

		// XN[o[TCYݒ
		if (LOWORD(lParam)<dwVSizeW) {

			iHSMin=0;
			iHSMax=dwVSizeW;
			iHSPage=LOWORD(lParam);

		} else {

			iHSMin=0;
			iHSMax=0;
			iHSPage=0;

		}

		// XN[o[ʒuݒ
		iHSPos=min(iHSPos,iHSMax-iHSPage);

		// SCROLLINFO\̐ݒ
		sInfo.nMin=iHSMin;
		sInfo.nMax=iHSMax;
		sInfo.nPage=iHSPage;

		// XN[o[ݒ
		SetScrollInfo(hwnd,SB_HORZ,&sInfo,TRUE);

		// XN[o[TCYݒ
		if (HIWORD(lParam)<dwVSizeH) {

			iVSMin=0;
			iVSMax=dwVSizeH;
			iVSPage=HIWORD(lParam);

		} else {

			iVSMin=0;
			iVSMax=0;
			iVSPage=0;

		}

		// XN[o[ʒuݒ
		iVSPos=min(iVSPos,iVSMax-iVSPage);

		// SCROLLINFO\̐ݒ
		sInfo.nMin=iVSMin;
		sInfo.nMax=iVSMax;
		sInfo.nPage=iVSPage;
		sInfo.nPos=iVSPos;

		// XN[o[ݒ
		SetScrollInfo(hwnd,SB_VERT,&sInfo,TRUE);

		// EChEĕ`
		InvalidateRgn(hwnd,NULL,FALSE);
		UpdateWindow(hwnd);

		return 0;

	case WM_HSCROLL: // XN[o[bZ[W

		switch(LOWORD(wParam)) {

		case SB_LINEUP:

			iHSd=-1;

			break;

		case SB_LINEDOWN:

			iHSd=1;

			break;

		case SB_PAGEUP:
	
			iHSd=-iHSPage;

			break;

		case SB_PAGEDOWN:
	
			iHSd=iHSPage;

			break;

		case SB_THUMBTRACK:
					
			iHSd=HIWORD(wParam)-iHSPos;
					
			break;

		default:

			iHSd=0;

		}

		if (iHSd!=0) {

			iHSPos+=iHSd;

			iHSPos=max(iHSPos,0);
			iHSPos=min(iHSPos,iHSMax-iHSPage);

			SetScrollPos(hwnd,SB_HORZ,iHSPos,TRUE);
			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow(hwnd);

		}

		return 0;

	case WM_VSCROLL: // XN[o[bZ[W

		switch(LOWORD(wParam)) {

		case SB_LINEUP:

			iVSd=-1;

			break;

		case SB_LINEDOWN:

			iVSd=1;

			break;

		case SB_PAGEUP:
	
			iVSd=-iVSPage;

			break;

		case SB_PAGEDOWN:
	
			iVSd=iVSPage;

			break;

		case SB_THUMBTRACK:
					
			iVSd=HIWORD(wParam)-iVSPos;
					
			break;

		default:

			iVSd=0;

		}

		if (iVSd!=0) {

			iVSPos+=iVSd;

			iVSPos=max(iVSPos,0);
			iVSPos=min(iVSPos,iVSMax-iVSPage);

			SetScrollPos(hwnd,SB_VERT,iVSPos,TRUE);
			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow(hwnd);

		}

		return 0;

	case WM_MOUSEMOVE:

		iPosX=(int)((LOWORD(lParam)+iHSPos)*(1/lfVSize));
		iPosY=(int)((dwVSizeH-(HIWORD(lParam)+iVSPos)-1)*(1/lfVSize));

		if (iPosX<0 || iPosX>=sbBM->getWidth() || iPosY>=sbBM->getHeight() || iPosY<0)
			return 0;

		iR=sbBM->getR(iPosX,iPosY);
		iG=sbBM->getG(iPosX,iPosY);
		iB=sbBM->getB(iPosX,iPosY);

		wsprintf(tmp,"(%d,%d):%d,%d,%d",iPosX,iPosY,iR,iG,iB);
		SendMessage(hwState,SB_SETTEXT,0,(long)tmp);

		return 0;

	case WM_PAINT:

		hdc=BeginPaint(hwnd,&ps);

		if (lfVSize<1) {

			SetStretchBltMode(hdc,HALFTONE);
			SetBrushOrgEx(hdc,0,0,NULL);

		} else
			SetStretchBltMode(hdc,COLORONCOLOR);

		saAgent.draw(sbBM,hdc,-iHSPos,-iVSPos,lfVSize); // DIB`

		if (iLX1>=0) {

			if (fTrim) {

				iLX1=iLX1-iHSPos;
				iLX2=iLX2-iHSPos;
				iLY1=iLY1-iVSPos;
				iLY2=iLY2-iVSPos;

			}

			SelectObject(hdc,pen1);
			MoveToEx(hdc,iLX1,iLY1,NULL);
			LineTo(hdc,iLX2,iLY1);
			MoveToEx(hdc,iLX2,iLY1,NULL);
			LineTo(hdc,iLX2,iLY2);
			MoveToEx(hdc,iLX2,iLY2,NULL);
			LineTo(hdc,iLX1,iLY2);
			MoveToEx(hdc,iLX1,iLY2,NULL);
			LineTo(hdc,iLX1,iLY1);

			SelectObject(hdc,pen2);
			MoveToEx(hdc,iLX1+1,iLY1-1,NULL);
			LineTo(hdc,iLX2-1,iLY1-1);
			MoveToEx(hdc,iLX2-1,iLY1-1,NULL);
			LineTo(hdc,iLX2-1,iLY2+1);
			MoveToEx(hdc,iLX2-1,iLY2+1,NULL);
			LineTo(hdc,iLX1+1,iLY2+1);
			MoveToEx(hdc,iLX1+1,iLY2+1,NULL);
			LineTo(hdc,iLX1+1,iLY1-1);

			SelectObject(hdc,GetStockObject(BLACK_PEN));

		}

		EndPaint(hwnd,&ps);

		return 0;

	case WM_DESTROY:

		DeleteObject(pen1);
		DeleteObject(pen2);

		return 0;

	}

	return DefWindowProc(hwnd,iMsg,wParam,lParam);

}

FILTER9INFO FilterDialog() { // JX^tB^_CAO֐

	HWND hwDialog;
	static FILTER9INFO f9Param;
	MSG msg;

	// _CAÕEChEvV[W|ɍ\̂̃AhXn
	DialogProc(NULL,(UINT)(&f9Param),0,0);

	// _CAO{bNX쐬
	hwDialog = CreateWindow("CDialog","3X3tB^",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  320,160,NULL,NULL,hInst,NULL);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (f9Param.lfDiv==0) { // _CAOʂԂ܂Ń[v
		
		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// CEChELɂă[_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	// _CAȎIʂԂ
	return f9Param;

}

bool resize() { // gk_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog = CreateWindow("CResizeDialog","TCY",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  240,188,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	ResizeDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v
		
		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

bool conv() { // _CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("CConvDialog","",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  380,240,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	ConvDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v
		
		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

// JX^tB^_CAOEChEvV[W|
LRESULT CALLBACK DialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwLv,hwLp;
	static FILTER9INFO * lpParam;
	int i,j;
	static char lpszBuf[64];

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpParam=(FILTER9INFO *)iMsg;
		lpParam->lfDiv=0;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		// {^쐬
		hwFil9Dialog[11]=CreateWindow("BUTTON","s(&G)",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  8,90,80,32,hwnd,(HMENU)11,hInst,NULL);

		hwFil9Dialog[12]=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  96,90,80,32,hwnd,(HMENU)12,hInst,NULL);

		// tB^s͗
		for (i=0;i<3;i++)
			for (j=0;j<3;j++) {

				hwFil9Dialog[j+i*3]=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		                   8+j*56,4+i*24,48,22,hwnd,(HMENU)(j+i*3),hInst,NULL);

			}

		hwLv=CreateWindow("STATIC","Zl",WS_CHILD | WS_VISIBLE|SS_CENTER,
                    180,30,56,22,hwnd,(HMENU)13,hInst,NULL);

		hwFil9Dialog[9]=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
                    184,52,48,22,hwnd,(HMENU)9,hInst,NULL);

		hwLp=CreateWindow("STATIC","Zl",WS_CHILD | WS_VISIBLE|SS_CENTER,
                    244,30,56,22,hwnd,(HMENU)13,hInst,NULL);

		hwFil9Dialog[10]=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
                    248,52,48,22,hwnd,(HMENU)10,hInst,NULL);

		return 0;

	case WM_SETFOCUS:

		SetFocus(hwFil9Dialog[0]);

		break;

	case WM_COMMAND: // R}hbZ[W

		switch (LOWORD(wParam)) {

		case 11: // s{^

			for (i=0;i<3;i++) // tB^̍s擾
				for (j=0;j<3;j++) {

					GetWindowText(hwFil9Dialog[j+(2-i)*3],lpszBuf,64);
					lpParam->lfMatrix[j+i*3]=atof(lpszBuf);

				}

			GetWindowText(hwFil9Dialog[9],lpszBuf,64);
			lpParam->lfDiv=atof(lpszBuf);

			GetWindowText(hwFil9Dialog[10],lpszBuf,64);
			lpParam->lfAdd=atof(lpszBuf);

			DestroyWindow(hwnd);

			break;

		case 12: // {^

			lpParam->lfDiv=9999;
			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_CTLCOLORSTATIC:

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY : // I

		if (lpParam->lfDiv==0) // ݒ肳ĂȂ9999
			lpParam->lfDiv=9999;

		return 0;

	}

	return DefWindowProc(hwnd,iMsg,wParam,lParam);
	
}

LRESULT CALLBACK ResizeDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	HWND hwL1,hwL2;
	static LPDWORD lpDone=NULL;
	static char lpszBuf[64];
	int iW,iH;
	double lfA;
	HDC hdcTmp;
	HBITMAP hbTmp,hbOld;

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		hwL1=CreateWindow("Static","",WS_CHILD | WS_VISIBLE,8,10,20,20,
		  hwnd,(HMENU)5,hInst,NULL);

		hwResizeDialog[0]=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
                32,8,48,22,hwnd,(HMENU)0,hInst,NULL);

		hwL2=CreateWindow("Static","",WS_CHILD | WS_VISIBLE,92,10,36,20,
		  hwnd,(HMENU)5,hInst,NULL);

		hwResizeDialog[1]=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  136,8,48,22,hwnd,(HMENU)1,hInst,NULL);

		// {^쐬
		hwResizeDialog[2]=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  16,48,72,32,hwnd,(HMENU)2,hInst,NULL);

		hwResizeDialog[3]=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  104,48,72,32,hwnd,(HMENU)3,hInst,NULL);

		hwResizeDialog[4]=CreateWindow("BUTTON","cێ",BS_AUTOCHECKBOX|WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  16,88,128,30,hwnd,(HMENU)4,hInst,NULL);
		SendMessage(hwResizeDialog[4],BM_SETCHECK,1,0);
		hwResizeDialog[5]=CreateWindow("BUTTON","APIgp",BS_AUTOCHECKBOX|WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  16,120,128,32,hwnd,(HMENU)5,hInst,NULL);
		SendMessage(hwResizeDialog[5],BM_SETCHECK,BST_UNCHECKED,0);

		wsprintf(lpszBuf,"%d",sbBM->getWidth());
		SetWindowText(hwResizeDialog[0],lpszBuf);
		wsprintf(lpszBuf,"%d",sbBM->getHeight());
		SetWindowText(hwResizeDialog[1],lpszBuf);

		break;

	case WM_SETFOCUS:

		SetFocus(hwResizeDialog[0]);

		break;

	case WM_COMMAND: // R}hbZ[W

		if (HIWORD(wParam)==EN_CHANGE && LOWORD(wParam)==0
		    && SendMessage(hwResizeDialog[4],BM_GETCHECK,0,0)
		    && GetFocus()==(HWND)lParam) {

			GetWindowText(hwResizeDialog[0],lpszBuf,64);
			iW=atoi(lpszBuf);

			lfA=(double)sbBM->getHeight()/(double)sbBM->getWidth();
			iH=(int)ceil(iW*lfA);

			wsprintf(lpszBuf,"%d",iH);
			SetWindowText(hwResizeDialog[1],lpszBuf);

		}

		if (HIWORD(wParam)==EN_CHANGE && LOWORD(wParam)==1
		    && SendMessage(hwResizeDialog[4],BM_GETCHECK,0,0)
		    && GetFocus()==(HWND)lParam) {

			GetWindowText(hwResizeDialog[1],lpszBuf,64);
			iH=atoi(lpszBuf);

			lfA=(double)sbBM->getWidth()/(double)sbBM->getHeight();
			iW=(int)ceil(iH*lfA);

			wsprintf(lpszBuf,"%d",iW);
			SetWindowText(hwResizeDialog[0],lpszBuf);

		}

		switch (LOWORD(wParam)) {

		case 2: // s{^

			GetWindowText(hwResizeDialog[0],lpszBuf,64);
			iW=atoi(lpszBuf);
			GetWindowText(hwResizeDialog[1],lpszBuf,64);
			iH=atoi(lpszBuf);

			/* APIgp */
			if (SendMessage(hwResizeDialog[5],BM_GETCHECK,0,0)) {

				hbTmp=CreateCompatibleBitmap(GetDC(hwnd),iW,iH);

				if (hbTmp==NULL) {

					MessageBox(hwnd,"rbg}bv쐬Ɏs܂BAPIgp`FbN͂čēxsĂB",
					  "G[",MB_OK);

					SendMessage(hwResizeDialog[5],BM_SETCHECK,BST_UNCHECKED,0);

					return 0;

				}

				*sbBack=*sbBM;

				hdcTmp=CreateCompatibleDC(GetDC(hwnd));
				
				hbOld=(HBITMAP)SelectObject(hdcTmp,hbTmp);

				SetStretchBltMode(hdcTmp,HALFTONE);
				SetBrushOrgEx(hdcTmp,0,0,NULL);
				sbBM->draw(hdcTmp,0,0,iW,iH);

				sbBM->reset(iW,iH);

				SelectObject(hdcTmp,hbOld);

				GetDIBits(hdcTmp,hbTmp,0,sbBM->getHeight(),
				  sbBM->getPixels(),sbBM->getInfo(),DIB_RGB_COLORS);

				// t[obt@̍ŏʂWrbgNA
				sbBM->trimRGB();

				DeleteObject(hbTmp);
				DeleteDC(hdcTmp);

			} else {

				*sbBack=*sbBM;

				sbBM->resize(iW,iH);

			}

			*lpDone=1;
			DestroyWindow(hwnd);

			break;

		case 3:

			DestroyWindow(hwnd);

			break;

		}

		break;

	case WM_CTLCOLORSTATIC:

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

			if (*lpDone!=1)
				*lpDone=2;

			break;

	}

	return DefWindowProc(hwnd,iMsg,wParam,lParam);

}

LRESULT CALLBACK ConvDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwMenu,hwOK,hwCansel,hwC1,hwC2,hwC3,hwL1,hwL2,hwL3;
	static LPDWORD lpDone=NULL;
	int iDC1,iDC2,iDC3,iMode;
	char str[16];
	static SDIB32 *sbPrev,*sbOri;
	HDC hdc;
	PAINTSTRUCT ps;

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

		case WM_CREATE: // EChE쐬̏

			iMode=0;

			hwMenu=CreateWindow("COMBOBOX",NULL,WS_CHILD|WS_VISIBLE|CBS_DROPDOWN|WS_TABSTOP,
			  4,4,72,90,hwnd,(HMENU)0,hInst,NULL);

			SendMessage(hwMenu,CB_ADDSTRING,-1,(LPARAM)"RGB");
			SendMessage(hwMenu,CB_ADDSTRING,-1,(LPARAM)"YCrCb");
			SendMessage(hwMenu,CB_SETCURSEL,0,1);
 
			// {^쐬
			hwOK=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
			  16,168,72,32,hwnd,(HMENU)1,hInst,NULL);

			// {^쐬
			hwCansel=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
			  100,168,72,32,hwnd,(HMENU)2,hInst,NULL);

			hwL1=CreateWindow("STATIC","R:0",WS_CHILD|WS_VISIBLE,
			      4,52,64,28,hwnd,(HMENU)2,hInst,NULL);
			hwC1=CreateWindow(TRACKBAR_CLASS,NULL,WS_CHILD|WS_VISIBLE|WS_TABSTOP,
			      64,48,160,32,hwnd,NULL,hInst,NULL);

			hwL2=CreateWindow("STATIC","G:0",WS_CHILD|WS_VISIBLE,
			      4,92,64,28,hwnd,(HMENU)2,hInst,NULL);
			hwC2=CreateWindow(TRACKBAR_CLASS,NULL,WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		          64,88,160,32,hwnd,NULL,hInst,NULL);

			hwL3=CreateWindow("STATIC","B:0",WS_CHILD|WS_VISIBLE,
			      4,132,64,28,hwnd,(HMENU)2,hInst,NULL);
			hwC3=CreateWindow(TRACKBAR_CLASS,NULL,WS_CHILD|WS_VISIBLE|WS_TABSTOP,
			      64,128,160,32,hwnd,NULL,hInst,NULL);

			SendMessage(hwC1,TBM_SETRANGEMIN,1,0);
			SendMessage(hwC1,TBM_SETRANGEMAX,1,128);
			SendMessage(hwC1,TBM_SETPOS,1,64);

			SendMessage(hwC2,TBM_SETRANGEMIN,1,0);
			SendMessage(hwC2,TBM_SETRANGEMAX,1,128);
			SendMessage(hwC2,TBM_SETPOS,1,64);

			SendMessage(hwC3,TBM_SETRANGEMIN,1,0);
			SendMessage(hwC3,TBM_SETRANGEMAX,1,128);
			SendMessage(hwC3,TBM_SETPOS,1,64);

			sbPrev=new SDIB32(sbBM);

			DWORD dwWid,dwHei;
			double lfRate;

			if (sbPrev->getWidth()>sbPrev->getHeight()) {

				if (sbPrev->getWidth()>128)
					lfRate=128.0/(double)sbPrev->getWidth();
				else
					lfRate=1;

			} else {

				if (sbPrev->getHeight()>128)
					lfRate=128.0/(double)sbPrev->getHeight();
				else
					lfRate=1;

			}

			dwWid=(DWORD)(sbPrev->getWidth()*lfRate);
			dwHei=(DWORD)(sbPrev->getHeight()*lfRate);

			sbPrev->resize(dwWid,dwHei);
			sbOri=new SDIB32(sbPrev);

			return 0;

		case WM_HSCROLL:

			// gbNo[̈ʒu␳lZo
			iDC1=SendMessage(hwC1,TBM_GETPOS,0,0)-64;
			iDC2=SendMessage(hwC2,TBM_GETPOS,0,0)-64;
			iDC3=SendMessage(hwC3,TBM_GETPOS,0,0)-64;

			*sbPrev=*sbOri;

			if (SendMessage(hwMenu,CB_GETCURSEL,0,0)==0) {

				saAgent.transR(sbPrev,iDC1);
				saAgent.transG(sbPrev,iDC2);
				saAgent.transB(sbPrev,iDC3);

				// xɌ݂̒l\
				wsprintf(str,"R:%d",iDC1);
				SetWindowText(hwL1,str);
				wsprintf(str,"G:%d",iDC2);
				SetWindowText(hwL2,str);
				wsprintf(str,"B:%d",iDC3);
				SetWindowText(hwL3,str);

			} else {

				sbPrev->setYUVtoBuffer();

				saAgent.transY(sbPrev,iDC1);
				saAgent.transU(sbPrev,iDC2);
				saAgent.transV(sbPrev,iDC3);

				sbPrev->setRGBtoPixels();

				// xɌ݂̒l\
				wsprintf(str,"Y:%d",iDC1);
				SetWindowText(hwL1,str);
				wsprintf(str,"Cr:%d",iDC2);
				SetWindowText(hwL2,str);
				wsprintf(str,"Cb:%d",iDC3);
				SetWindowText(hwL3,str);

			}

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow(hwnd);

			return 0;

		case WM_COMMAND: // R}hbZ[W

			switch (LOWORD(wParam)) {

			case 0: // RGB-YCrCbj[

				// gbNo[̈ʒu␳lZo
				iDC1=SendMessage(hwC1,TBM_GETPOS,0,0)-64;
				iDC2=SendMessage(hwC2,TBM_GETPOS,0,0)-64;
				iDC3=SendMessage(hwC3,TBM_GETPOS,0,0)-64;

				if (SendMessage(hwMenu,CB_GETCURSEL,0,0)==0) {

					// xɌ݂̒l\
					wsprintf(str,"R:%d",iDC1);
					SetWindowText(hwL1,str);
					wsprintf(str,"G:%d",iDC2);
					SetWindowText(hwL2,str);
					wsprintf(str,"B:%d",iDC3);
					SetWindowText(hwL3,str);

				} else {

					// xɌ݂̒l\
					wsprintf(str,"Y:%d",iDC1);
					SetWindowText(hwL1,str);
					wsprintf(str,"Cr:%d",iDC2);
					SetWindowText(hwL2,str);
					wsprintf(str,"Cb:%d",iDC3);
					SetWindowText(hwL3,str);

				}

				break;

			case 1: // s{^

				iDC1=SendMessage(hwC1,TBM_GETPOS,0,0)-64;
				iDC2=SendMessage(hwC2,TBM_GETPOS,0,0)-64;
				iDC3=SendMessage(hwC3,TBM_GETPOS,0,0)-64;

				*sbBack=*sbBM;

				if (SendMessage(hwMenu,CB_GETCURSEL,0,0)==0) {

					saAgent.transR(sbBM,iDC1);
					saAgent.transG(sbBM,iDC2);
					saAgent.transB(sbBM,iDC3);

				} else {

					sbBM->setYUVtoBuffer();

					saAgent.transY(sbBM,iDC1);
					saAgent.transU(sbBM,iDC2);
					saAgent.transV(sbBM,iDC3);

					sbBM->setRGBtoPixels();

				}

				*lpDone=1;

				DestroyWindow(hwnd);

				break;

			case 2: // {^

				DestroyWindow(hwnd);

				break;

			}

			return 0;

		case WM_PAINT:

			hdc=BeginPaint(hwnd,&ps);
			saAgent.draw(sbPrev,hdc,232,8);
			EndPaint(hwnd,&ps);

			return 0;

		case WM_CTLCOLORSTATIC: // x̔wiFݒ

			return (LRESULT)GetStockObject(WHITE_BRUSH);

		case WM_DESTROY:

				if (*lpDone!=1)
					*lpDone=2;

				delete sbPrev;

				break;

	}

	return DefWindowProc(hwnd,iMsg,wParam,lParam);

}

RGBINFO RGBDialog() { // RGBϊ_CAO֐

	HWND hwDialog;
	static RGBINFO rParam;
	MSG msg;

	// _CAÕEChEvV[W|ɍ\̂̃AhXn
	RGBDialogProc(NULL,(UINT)(&rParam),0,0);

	// _CAO{bNX쐬
	hwDialog = CreateWindow("CRGBDialog","RGBϊ",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  480,176,NULL,NULL,hInst,NULL);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (rParam.dwFlg==0) { // _CAOʂԂ܂Ń[v
		
		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// CEChELɂă[_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	// _CAȎIʂԂ
	return rParam;

}

LRESULT CALLBACK RGBDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwLp[12];
	static RGBINFO * lpParam;
	int i,j;
	static char lpszBuf[64];
	static SDIB32 *sbPrev,*sbOri;
	HDC hdc;
	PAINTSTRUCT ps;
	static RGBINFO rTmp;

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpParam=(RGBINFO *)iMsg;
		lpParam->dwFlg=0;

		return 0;

	}

	switch (iMsg) {

		case WM_CREATE: // EChE쐬̏

			// {^쐬
			hwRGBDialog[12]=CreateWindow("BUTTON","vr[",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
			  8,104,112,32,hwnd,(HMENU)12,hInst,NULL);

			hwRGBDialog[13]=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
			  148,104,72,32,hwnd,(HMENU)13,hInst,NULL);

			hwRGBDialog[14]=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
			  236,104,72,32,hwnd,(HMENU)14,hInst,NULL);

			hwLp[0]=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_RIGHT,
                  2,6,28,18,hwnd,(HMENU)15,hInst,NULL);
			SetWindowText(hwLp[0],"R=");

			hwLp[4]=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_RIGHT,
                  2,38,28,18,hwnd,(HMENU)19,hInst,NULL);
			SetWindowText(hwLp[4],"G=");

			hwLp[8]=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_RIGHT,
                  2,70,28,18,hwnd,(HMENU)23,hInst,NULL);
			SetWindowText(hwLp[8],"B=");

			for (i=0;i<3;i++) {

				hwLp[i*4+1]=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_RIGHT,
		              82,6+i*32,28,18,hwnd,(HMENU)(15+i*4+1),hInst,NULL);
				SetWindowText(hwLp[i*4+1],"R+");

				hwLp[i*4+2]=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_RIGHT,
		              162,6+i*32,28,18,hwnd,(HMENU)(15+i*4+2),hInst,NULL);
				SetWindowText(hwLp[i*4+2],"G+");

				hwLp[i*4+3]=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_RIGHT,
		              242,6+i*32,28,18,hwnd,(HMENU)(15+i*4+3),hInst,NULL);
				SetWindowText(hwLp[i*4+3],"B+");

				for (j=0;j<4;j++) {

					hwRGBDialog[j+i*4]=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
			                   32+j*80,4+i*32,52,22,hwnd,(HMENU)(j+i*4),hInst,NULL);

					SetWindowText(hwRGBDialog[j+i*4],"0");

				}

			}

			sbPrev=new SDIB32(sbBM);

			DWORD dwWid,dwHei;
			double lfRate;

			if (sbPrev->getWidth()>sbPrev->getHeight()) {

				if (sbPrev->getWidth()>128)
					lfRate=128.0/(double)sbPrev->getWidth();
				else
					lfRate=1;

			} else {

				if (sbPrev->getHeight()>128)
					lfRate=128.0/(double)sbPrev->getHeight();
				else
					lfRate=1;

			}

			dwWid=(DWORD)(sbPrev->getWidth()*lfRate);
			dwHei=(DWORD)(sbPrev->getHeight()*lfRate);

			sbPrev->resize(dwWid,dwHei);
			sbOri=new SDIB32(*sbPrev);

			return 0;

		case WM_SETFOCUS:

			SetFocus(hwRGBDialog[0]);

			break;

		case WM_COMMAND: // R}hbZ[W

			switch (LOWORD(wParam)) {

				case 12: // vr[{^

					*sbPrev=*sbOri;

					for (i=0;i<3;i++) // ϊ̃p[^擾
						for (j=0;j<4;j++) {

							GetWindowText(hwRGBDialog[j+i*4],lpszBuf,64);
							rTmp.lfParam[j+i*4]=atof(lpszBuf);

						}

					saAgent.calcRGB(sbPrev,&rTmp);

					InvalidateRgn(hwnd,NULL,FALSE);
					UpdateWindow(hwnd);

					break;

				case 13: // s{^

					for (i=0;i<3;i++) // ϊ̃p[^擾
						for (j=0;j<4;j++) {

							GetWindowText(hwRGBDialog[j+i*4],lpszBuf,64);
							lpParam->lfParam[j+i*4]=atof(lpszBuf);

						}

					lpParam->dwFlg=1;

					DestroyWindow(hwnd);

					break;

				case 14: // {^

					lpParam->dwFlg=2;
					DestroyWindow(hwnd);

					break;

			}

			return 0;

		case WM_CTLCOLORSTATIC:

			return (LRESULT)GetStockObject(WHITE_BRUSH);

		case WM_PAINT:

			hdc=BeginPaint(hwnd,&ps);
			saAgent.draw(sbPrev,hdc,332,4);
			EndPaint(hwnd,&ps);

			return 0;

		case WM_DESTROY : // I

			delete sbPrev,sbOri;

			if (lpParam->dwFlg==0)
				lpParam->dwFlg=2;

			return 0;

	}

	return DefWindowProc(hwnd,iMsg,wParam,lParam);
	
}

bool unsharp() { // AV[v}XN_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("CUnsharpDialog","AV[v}XN",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  320,180,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	UnsharpDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v
		
		GetMessage(&msg,NULL,0,0);

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK UnsharpDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwOK,hwCansel,hwC1,hwC2,hwL1,hwL2;
	static LPDWORD lpDone=NULL;
	int iDC1,iDC2;
	double lfV;

	char str[16];

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

		case WM_CREATE: // EChE쐬̏

			// {^쐬
			hwOK=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE,
			  32,108,72,32,hwnd,(HMENU)1,hInst,NULL);
			hwCansel=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE,
			  120,108,72,32,hwnd,(HMENU)2,hInst,NULL);

			hwL1=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_RIGHT,
                  4,8,88,30,hwnd,(HMENU)15,hInst,NULL);
			SetWindowText(hwL1,"͈:1");

			hwC1=CreateWindow(TRACKBAR_CLASS,NULL,WS_CHILD|WS_VISIBLE,
			      96,8,160,32,hwnd,NULL,hInst,NULL);

			hwL2=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_RIGHT,
                  4,48,88,30,hwnd,(HMENU)15,hInst,NULL);
			SetWindowText(hwL2,"x:0.0");

			hwC2=CreateWindow(TRACKBAR_CLASS,NULL,WS_CHILD|WS_VISIBLE,
		          96,48,160,32,hwnd,NULL,hInst,NULL);

			SendMessage(hwC1,TBM_SETRANGEMIN,1,1);
			SendMessage(hwC1,TBM_SETRANGEMAX,1,6);
			SendMessage(hwC1,TBM_SETPOS,1,1);

			SendMessage(hwC2,TBM_SETRANGEMIN,1,0);
			SendMessage(hwC2,TBM_SETRANGEMAX,1,40);
			SendMessage(hwC2,TBM_SETPOS,1,20);

			return 0;

		case WM_HSCROLL:

			// gbNo[̈ʒu␳lZo
			iDC1=SendMessage(hwC1,TBM_GETPOS,0,0);
			iDC2=SendMessage(hwC2,TBM_GETPOS,0,0)-20;
			lfV=0.2*iDC2;

			// xɌ݂̒l\
			wsprintf(str,"͈:%d",iDC1);
			SetWindowText(hwL1,str);
			sprintf(str,"x:%1.1lf",lfV);
			SetWindowText(hwL2,str);

			return 0;

		case WM_COMMAND: // R}hbZ[W

			switch (LOWORD(wParam)) {

			case 1: // s{^

				// gbNo[̈ʒu␳lZo
				iDC1=SendMessage(hwC1,TBM_GETPOS,0,0);
				iDC2=SendMessage(hwC2,TBM_GETPOS,0,0)-20;
				lfV=0.2*iDC2;

				*sbBack=*sbBM;
				saAgent.unsharp(sbBM,iDC1,lfV);

				*lpDone=1;
				DestroyWindow(hwnd);

				break;

			case 2: // {^

				DestroyWindow(hwnd);

				break;

			}

			return 0;

		case WM_CTLCOLORSTATIC: // x̔wiFݒ

			return (LRESULT)GetStockObject(WHITE_BRUSH);

		case WM_DESTROY:

			if (*lpDone!=1)
				*lpDone=2;

			break;

	}

	return DefWindowProc(hwnd,iMsg,wParam,lParam);

}

bool cont() { // xRgXg_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("CContDialog","xRgXg",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  600,320,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	ContDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v
		
		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK ContDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwLp[5];
	static LPDWORD lpDone=NULL;
	static HBITMAP hBMP;
	static HDC hdc,hdcBMP;
	PAINTSTRUCT ps;
	static RECT recBMP={0,0,272,232},recStr={0,0,256,20};
	DWORD dwMin=255,dwMax=0,dwNMax=0,dwMaxI=0;
	static DWORD dwYs[256];
	int i,j,iMin,iMax,iMin2,iMax2,iPosX,iPosY;
	static SDIB32 *sbPrev,*sbOri;
	char str[64];

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		hwLp[0]=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_LEFT,
		  280,8,160,30,hwnd,(HMENU)15,hInst,NULL);
		SetWindowText(hwLp[0],"摜x͈");

		hwLp[1]=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_CENTER,
          328,42,22,20,hwnd,(HMENU)15,hInst,NULL);
		SetWindowText(hwLp[1],"`");

		hwLp[2]=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_LEFT,
          280,80,160,22,hwnd,(HMENU)15,hInst,NULL);
		SetWindowText(hwLp[2],"ϊ摜x͈");

		hwLp[3]=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_CENTER,
          328,104,22,20,hwnd,(HMENU)15,hInst,NULL);
		SetWindowText(hwLp[3],"`");

		hwLp[4]=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_LEFT,
		  8,232,256,20,hwnd,(HMENU)15,hInst,NULL);
		SetWindowText(hwLp[4],"x:");

		for (i=0;i<2;i++)
			for (j=0;j<2;j++) {

				hwContDialog[j+i*2]=CreateWindow("Edit",NULL,WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP,
				  280+j*68,32+i*72,48,22,hwnd,(HMENU)(j+i*2),hInst,NULL);

			}

		// {^쐬
		hwContDialog[4]=CreateWindow("BUTTON","vr[",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  280,168,96,32,hwnd,(HMENU)4,hInst,NULL);

		hwContDialog[5]=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  388,168,72,32,hwnd,(HMENU)5,hInst,NULL);

		hwContDialog[6]=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  488,168,72,32,hwnd,(HMENU)6,hInst,NULL);

		hdcBMP=CreateCompatibleDC(GetDC(hwnd));
		hBMP=CreateCompatibleBitmap(hdcBMP,272,222);
		SelectObject(hdcBMP,hBMP);
		SelectObject(hdcBMP,GetStockObject(BLACK_PEN));

		FillRect(hdcBMP,&recBMP,(HBRUSH)GetStockObject(WHITE_BRUSH));
		MoveToEx(hdcBMP,8,20,NULL);
		LineTo(hdcBMP,264,20);
		LineTo(hdcBMP,264,220);
		LineTo(hdcBMP,8,220);
		LineTo(hdcBMP,8,20);

		for (i=0;i<256;i++)
			dwYs[i]=0;

		for (i=0;i<sbBM->getHeight();i++)
			for (j=0;j<sbBM->getWidth();j++)
				dwYs[sbBM->getY(j,i)]++;

		for (i=0;i<256;i++) {

			if (dwYs[i]>0 && dwMin==255)
				dwMin=i;

			if (dwYs[255-i]>0 && dwMax==0)
				dwMax=255-i;

			if (dwNMax<dwYs[i]) {

				dwNMax=dwYs[i];
				dwMaxI=i;

			}

		}

		wsprintf(str,"%d",dwMin);
		SetWindowText(hwContDialog[0],str);
		wsprintf(str,"%d",dwMax);
		SetWindowText(hwContDialog[1],str);

		wsprintf(str,"xő-%d:%dsNZ",dwMaxI,dwNMax);
		DrawText(hdcBMP,str,-1,&recStr,DT_LEFT);

		for (i=0;i<256;i++) {

			MoveToEx(hdcBMP,i+9,220,NULL);
			j=(DWORD)((double)(dwYs[i]*200)/(double)dwNMax);
			LineTo(hdcBMP,i+9,220-j);

		}

		sbPrev=new SDIB32(sbBM);

		DWORD dwWid,dwHei;
		double lfRate;

		if (sbPrev->getWidth()>sbPrev->getHeight()) {

			if (sbPrev->getWidth()>128)
				lfRate=128.0/(double)sbPrev->getWidth();
			else
				lfRate=1;

		} else {

			if (sbPrev->getHeight()>128)
				lfRate=128.0/(double)sbPrev->getHeight();
			else
				lfRate=1;

		}

		dwWid=(DWORD)(sbPrev->getWidth()*lfRate);
		dwHei=(DWORD)(sbPrev->getHeight()*lfRate);

		sbPrev->resize(dwWid,dwHei);
		sbOri=new SDIB32(sbPrev);

		return 0;

	case WM_MOUSEMOVE:

		iPosX=LOWORD(lParam)-13;
		iPosY=HIWORD(lParam)-24;

		if (iPosX<0 || iPosX>255 || iPosY<0 || iPosY>200)
			return 0;

		wsprintf(str,"x:%d-%dsNZ",iPosX,dwYs[iPosX]);
		SetWindowText(hwLp[4],str);

		return 0;

	case WM_COMMAND: // R}hbZ[W

		switch (LOWORD(wParam)) {

		case 4: // vr[

			GetWindowText(hwContDialog[0],str,16);
			iMin=atol(str);
			GetWindowText(hwContDialog[1],str,16);
			iMax=atol(str);
			GetWindowText(hwContDialog[2],str,16);
			iMin2=atol(str);
			GetWindowText(hwContDialog[3],str,16);
			iMax2=atol(str);

			if (iMin<iMax && iMin2<iMax2) {

				*sbPrev=*sbOri;

				saAgent.contY(sbPrev,iMin,iMax,iMin2,iMax2);

				InvalidateRgn(hwnd,NULL,FALSE);
				UpdateWindow(hwnd);

			}

			break;

		case 5: // s{^

			GetWindowText(hwContDialog[0],str,16);
			iMin=atol(str);
			GetWindowText(hwContDialog[1],str,16);
			iMax=atol(str);
			GetWindowText(hwContDialog[2],str,16);
			iMin2=atol(str);
			GetWindowText(hwContDialog[3],str,16);
			iMax2=atol(str);

			if (iMin<iMax && iMin2<iMax2) {

				*sbBack=*sbBM;
				saAgent.contY(sbBM,iMin,iMax,iMin2,iMax2);

				*lpDone=1;

			}

			DestroyWindow(hwnd);

			break;

		case 6: // {^

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_CTLCOLORSTATIC: // x̔wiFݒ

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_PAINT:

		hdc=BeginPaint(hwnd,&ps);

		BitBlt(hdc,4,4,272,240,hdcBMP,0,0,SRCCOPY);
		saAgent.draw(sbPrev,hdc,440,8);

		EndPaint(hwnd,&ps);

		return 0;

	case WM_DESTROY:

		if (*lpDone!=1)
			*lpDone=2;

		delete sbPrev,sbOri;

		break;

	}

	return DefWindowProc(hwnd,iMsg,wParam,lParam);

}

bool contS() { // ʓx_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("CContSDialog","ʓx",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  320,200,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	ContSDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v
		
		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK ContSDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwOK,hwCansel,hwC,hwL;
	static LPDWORD lpDone=NULL;
	int iDC;
	char str[16];
	static SDIB32 *sbPrev,*sbOri;
	HDC hdc;
	PAINTSTRUCT ps;

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		// {^쐬
		hwOK=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  8,100,72,32,hwnd,(HMENU)1,hInst,NULL);

		// {^쐬
		hwCansel=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  96,100,72,32,hwnd,(HMENU)2,hInst,NULL);

		hwL=CreateWindow("STATIC","ʓx:0",WS_CHILD|WS_VISIBLE,
		      4,8,160,28,hwnd,(HMENU)2,hInst,NULL);
		hwC=CreateWindow(TRACKBAR_CLASS,NULL,WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		      4,48,160,32,hwnd,NULL,hInst,NULL);

		SendMessage(hwC,TBM_SETRANGEMIN,1,0);
		SendMessage(hwC,TBM_SETRANGEMAX,1,64);
		SendMessage(hwC,TBM_SETPOS,1,32);

		sbPrev=new SDIB32(sbBM);

		DWORD dwWid,dwHei;
		double lfRate;

		if (sbPrev->getWidth()>sbPrev->getHeight()) {

			if (sbPrev->getWidth()>128)
				lfRate=128.0/(double)sbPrev->getWidth();
			else
				lfRate=1;

		} else {

			if (sbPrev->getHeight()>128)
				lfRate=128.0/(double)sbPrev->getHeight();
			else
				lfRate=1;

		}

		dwWid=(DWORD)(sbPrev->getWidth()*lfRate);
		dwHei=(DWORD)(sbPrev->getHeight()*lfRate);

		sbPrev->resize(dwWid,dwHei);
		sbOri=new SDIB32(sbPrev);

		return 0;

	case WM_HSCROLL:

		// gbNo[̈ʒu␳lZo
		iDC=SendMessage(hwC,TBM_GETPOS,0,0)-32;

		*sbPrev=*sbOri;

		saAgent.contS(sbPrev,iDC);

		// xɌ݂̒l\
		wsprintf(str,"ʓx:%d",iDC);
		SetWindowText(hwL,str);

		InvalidateRgn(hwnd,NULL,FALSE);
		UpdateWindow(hwnd);

		return 0;

	case WM_COMMAND: // R}hbZ[W

		switch (LOWORD(wParam)) {

		case 1: // s{^

			*sbBack=*sbBM;

			// gbNo[̈ʒu␳lZo
			iDC=SendMessage(hwC,TBM_GETPOS,0,0)-32;

			saAgent.contS(sbBM,iDC);

			*lpDone=1;

			DestroyWindow(hwnd);

			break;

		case 2: // {^

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_PAINT:

		hdc=BeginPaint(hwnd,&ps);
		saAgent.draw(sbPrev,hdc,176,8);
		EndPaint(hwnd,&ps);

		return 0;

	case WM_CTLCOLORSTATIC: // x̔wiFݒ

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

		if (*lpDone!=1)
			*lpDone=2;

		delete sbPrev,sbOri;

		break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool fog() { // ڂ_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("CFogDialog","ڂ",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  340,180,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	FogDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v
		
		GetMessage(&msg,NULL,0,0);

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK FogDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwOK,hwCansel,hwC1,hwC2,hwL1,hwL2;
	static LPDWORD lpDone=NULL;
	int iDC1,iDC2;
	double lfV;

	char str[32];

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		// {^쐬
		hwOK=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE,
		  32,108,72,32,hwnd,(HMENU)1,hInst,NULL);
		hwCansel=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE,
		  120,108,72,32,hwnd,(HMENU)2,hInst,NULL);

		hwL1=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_RIGHT,
          0,8,144,30,hwnd,(HMENU)15,hInst,NULL);
		SetWindowText(hwL1,"ω͈:1");

		hwC1=CreateWindow(TRACKBAR_CLASS,NULL,WS_CHILD|WS_VISIBLE,
	     148,8,160,32,hwnd,NULL,hInst,NULL);

		hwL2=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_RIGHT,
		  0,48,144,30,hwnd,(HMENU)15,hInst,NULL);
		SetWindowText(hwL2,"SfZx:1.0");

		hwC2=CreateWindow(TRACKBAR_CLASS,NULL,WS_CHILD|WS_VISIBLE,
	          148,48,160,32,hwnd,NULL,hInst,NULL);

		SendMessage(hwC1,TBM_SETRANGEMIN,1,1);
		SendMessage(hwC1,TBM_SETRANGEMAX,1,6);
		SendMessage(hwC1,TBM_SETPOS,1,1);

		SendMessage(hwC2,TBM_SETRANGEMIN,1,0);
		SendMessage(hwC2,TBM_SETRANGEMAX,1,40);
		SendMessage(hwC2,TBM_SETPOS,1,25);

		return 0;

	case WM_HSCROLL:

		// gbNo[̈ʒu␳lZo
		iDC1=SendMessage(hwC1,TBM_GETPOS,0,0);
		iDC2=SendMessage(hwC2,TBM_GETPOS,0,0)-20;
		lfV=0.2*iDC2;

		// xɌ݂̒l\
		wsprintf(str,"ω͈:%d",iDC1);
		SetWindowText(hwL1,str);
		sprintf(str,"SfZx:%1.1lf",lfV);
		SetWindowText(hwL2,str);

		return 0;

	case WM_COMMAND: // R}hbZ[W

		switch (LOWORD(wParam)) {

		case 1: // s{^

			// gbNo[̈ʒu␳lZo
			iDC1=SendMessage(hwC1,TBM_GETPOS,0,0);
			iDC2=SendMessage(hwC2,TBM_GETPOS,0,0)-20;
			lfV=0.2*iDC2;

			*sbBack=*sbBM;
			sbBM->fog(iDC1,lfV);

			*lpDone=1;
			DestroyWindow(hwnd);

			break;

		case 2: // {^

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_CTLCOLORSTATIC: // x̔wiFݒ

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

		if (*lpDone!=1)
			*lpDone=2;

		break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool trim() { // g_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog = CreateWindow("CTrimDialog","g~O",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  200,192,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	TrimDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v
		
		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK TrimDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	HWND hwL1,hwL2;
	static LPDWORD lpDone=NULL;
	static char lpszBuf[64];
	int iSX,iSY,iW,iH;
	
	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		hwL1=CreateWindow("Static","[W",WS_CHILD | WS_VISIBLE,8,10,160,20,
		  hwnd,(HMENU)6,hInst,NULL);

		hwTrimDialog[0]=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER,
		   8,32,48,22,hwnd,(HMENU)0,hInst,NULL);
		hwTrimDialog[1]=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER,
		   64,32,48,22,hwnd,(HMENU)1,hInst,NULL);

		hwL2=CreateWindow("Static","傫",WS_CHILD | WS_VISIBLE,8,60,160,20,
		  hwnd,(HMENU)7,hInst,NULL);
		hwTrimDialog[2]=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER,
		  8,88,48,22,hwnd,(HMENU)2,hInst,NULL);
		hwTrimDialog[3]=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER,
           64,88,48,22,hwnd,(HMENU)3,hInst,NULL);

		// {^쐬
		hwTrimDialog[4]=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE,
		  8,120,72,32,hwnd,(HMENU)4,hInst,NULL);

		hwTrimDialog[5]=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE,
		  100,120,72,32,hwnd,(HMENU)5,hInst,NULL);

		SetFocus(hwTrimDialog[0]);

		break;

	case WM_SETFOCUS:

		SetFocus(hwResizeDialog[0]);

		break;

	case WM_COMMAND: // R}hbZ[W

		if (HIWORD(wParam)==EN_CHANGE) {

			GetWindowText(hwTrimDialog[0],lpszBuf,64);
			iSX=atoi(lpszBuf);
			GetWindowText(hwTrimDialog[1],lpszBuf,64);
			iSY=atoi(lpszBuf);
			GetWindowText(hwTrimDialog[2],lpszBuf,64);
			iW=atoi(lpszBuf);
			GetWindowText(hwTrimDialog[3],lpszBuf,64);
			iH=atoi(lpszBuf);

			if (iSX<0 || iSX>=sbBM->getWidth()-1 || iSY<0 || iSY>=sbBM->getHeight()-1
				|| iW<1 || iH<1) {

				iLX1=-1;
				InvalidateRgn(hwMain,NULL,FALSE);
				UpdateWindow (hwMain);

				break;

			}

			iLX1=iSX;
			iLY1=sbBM->getHeight()-iSY-1;
			iLX2=iSX+iW;
			iLY2=sbBM->getHeight()-(iSY+iH)-1;

			if (iLX2>=sbBM->getWidth())
				iLX2=sbBM->getWidth()-1;
			if (iLY2>=sbBM->getHeight())
				iLY2=sbBM->getHeight()-1;
			if (iLY2<0)
				iLY2=0;

			iLX1=(int)((double)iLX1*lfVSize);
			iLX2=(int)((double)iLX2*lfVSize);
			iLY1=(int)((double)iLY1*lfVSize);
			iLY2=(int)((double)iLY2*lfVSize);

			fTrim=TRUE;
			InvalidateRgn(hwMain,NULL,FALSE);
			UpdateWindow (hwMain);
			fTrim=FALSE;

			break;

		}

		switch (LOWORD(wParam)) {

		case 4: // s{^

			GetWindowText(hwTrimDialog[0],lpszBuf,64);
			iSX=atoi(lpszBuf);
			GetWindowText(hwTrimDialog[1],lpszBuf,64);
			iSY=atoi(lpszBuf);
			GetWindowText(hwTrimDialog[2],lpszBuf,64);
			iW=atoi(lpszBuf);
			GetWindowText(hwTrimDialog[3],lpszBuf,64);
			iH=atoi(lpszBuf);

			*sbBack=*sbBM;
			sbBM->trim(iSX,iSY,iW,iH);

			*lpDone=1;
			DestroyWindow(hwnd);

			break;

		case 5: // {^

			DestroyWindow(hwnd);

			break;

		}

		break;

	case WM_CTLCOLORSTATIC:

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

			iLX1=-1;

			if (*lpDone!=1)
				*lpDone=2;

			break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool exPixel() { // sNZ_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("CExPixelDialog","sNZ",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  200,200,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	ExPixelDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v
		
		GetMessage(&msg,NULL,0,0);

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK ExPixelDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwOK,hwCansel,hwC,hwL;
	static LPDWORD lpDone=NULL;
	char str[18];
	int iDC,i,j,x,y;
	DWORD w;

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		// {^쐬
		hwOK=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE,
		  8,100,72,32,hwnd,(HMENU)1,hInst,NULL);

		// {^쐬
		hwCansel=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE,
		  96,100,72,32,hwnd,(HMENU)2,hInst,NULL);

		hwL=CreateWindow("STATIC","m:10%",WS_CHILD|WS_VISIBLE,
		      4,8,160,28,hwnd,(HMENU)2,hInst,NULL);
		hwC=CreateWindow(TRACKBAR_CLASS,NULL,WS_CHILD|WS_VISIBLE,
		      4,48,160,32,hwnd,NULL,hInst,NULL);

		SendMessage(hwC,TBM_SETRANGEMIN,1,0);
		SendMessage(hwC,TBM_SETRANGEMAX,1,100);
		SendMessage(hwC,TBM_SETPOS,1,10);

		return 0;

	case WM_HSCROLL:

		// xɌ݂̒l\
		wsprintf(str,"m:%d",SendMessage(hwC,TBM_GETPOS,0,0));
		lstrcat(str,"%");

		SetWindowText(hwL,str);

		return 0;

	case WM_COMMAND: // R}hbZ[W

		switch (LOWORD(wParam)) {

		case 1: // s{^

			*sbBack=*sbBM;

			// gbNo[̈ʒu␳lZo
			iDC=SendMessage(hwC,TBM_GETPOS,0,0);

			/* sNZ̈ʒuw肳ꂽmŌ */
			for (i=0;i<sbBM->getHeight();i++)
				for (j=0;j<sbBM->getWidth();j++)
					if ((rand() % 100)<iDC) {

						x=rand() % sbBM->getWidth();
						y=rand() % sbBM->getHeight();

						w=sbBM->getRGB(j,i);
						sbBM->setRGB(j,i,sbBM->getRGB(x,y));
						sbBM->setRGB(x,y,w);

					}

			*lpDone=1;

			DestroyWindow(hwnd);

			break;

		case 2: // {^

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_CTLCOLORSTATIC: // x̔wiFݒ

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

		if (*lpDone!=1)
			*lpDone=2;

		break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool gamma() { // ʓx_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("CGammaDialog","K}␳",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  320,200,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	GammaDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v
		
		GetMessage(&msg,NULL,0,0);

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK GammaDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwOK,hwCansel,hwC,hwL;
	static LPDWORD lpDone=NULL;
	int iDC;
	char str[24];
	static SDIB32 *sbPrev,*sbOri;
	HDC hdc;
	PAINTSTRUCT ps;
	double lfG;

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		// {^쐬
		hwOK=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE,
		  8,100,72,32,hwnd,(HMENU)1,hInst,NULL);

		// {^쐬
		hwCansel=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE,
		  96,100,72,32,hwnd,(HMENU)2,hInst,NULL);

		hwL=CreateWindow("STATIC","K}␳:1.0",WS_CHILD|WS_VISIBLE,
		      4,8,160,28,hwnd,(HMENU)2,hInst,NULL);
		hwC=CreateWindow(TRACKBAR_CLASS,NULL,WS_CHILD|WS_VISIBLE,
		      4,48,160,32,hwnd,NULL,hInst,NULL);

		SendMessage(hwC,TBM_SETRANGEMIN,1,1);
		SendMessage(hwC,TBM_SETRANGEMAX,1,100);
		SendMessage(hwC,TBM_SETPOS,1,50);

		sbPrev=new SDIB32(sbBM);

		DWORD dwWid,dwHei;
		double lfRate;

		if (sbPrev->getWidth()>sbPrev->getHeight()) {

			if (sbPrev->getWidth()>128)
				lfRate=128.0/(double)sbPrev->getWidth();
			else
				lfRate=1;

		} else {

			if (sbPrev->getHeight()>128)
				lfRate=128.0/(double)sbPrev->getHeight();
			else
				lfRate=1;

		}

		dwWid=(DWORD)(sbPrev->getWidth()*lfRate);
		dwHei=(DWORD)(sbPrev->getHeight()*lfRate);

		sbPrev->resize(dwWid,dwHei);
		sbOri=new SDIB32(sbPrev);

		return 0;

	case WM_HSCROLL:

		// gbNo[̈ʒu␳lZo
		iDC=SendMessage(hwC,TBM_GETPOS,0,0)-50;
		lfG=1.0+((double)iDC/50);

		*sbPrev=*sbOri;

		saAgent.gamma(sbPrev,lfG);

		// xɌ݂̒l\
		sprintf(str,"K}␳:%1.2lf",lfG);
		SetWindowText(hwL,str);

		InvalidateRgn(hwnd,NULL,FALSE);
		UpdateWindow(hwnd);

		return 0;

	case WM_COMMAND: // R}hbZ[W

		switch (LOWORD(wParam)) {

		case 1: // s{^

			*sbBack=*sbBM;

			// gbNo[̈ʒu␳lZo
			iDC=SendMessage(hwC,TBM_GETPOS,0,0)-50;
			lfG=1.0+((double)iDC/50);

			saAgent.gamma(sbBM,lfG);

			*lpDone=1;

			DestroyWindow(hwnd);

			break;

		case 2: // {^

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_PAINT:

		hdc=BeginPaint(hwnd,&ps);
		saAgent.draw(sbPrev,hdc,176,8);
		EndPaint(hwnd,&ps);

		return 0;

	case WM_CTLCOLORSTATIC: // x̔wiFݒ

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

		if (*lpDone!=1)
			*lpDone=2;

		delete sbPrev,sbOri;

		break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool post() { // KύX_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("CPostDialog","KύX",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  320,200,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	PostDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v

		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK PostDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwOK,hwCansel,hwC,hwEditR,hwUdR,hwEditG,hwUdG,hwEditB,hwUdB;
	static HWND hwRp1,hwGp1,hwBp1,hwRp2,hwGp2,hwBp2;
	static LPDWORD lpDone=NULL;
	static SDIB32 *sbPrev,*sbOri;
	HDC hdc;
	PAINTSTRUCT ps;
	I32 r,g,b;
	CHAR str[17];

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		sbPrev=new SDIB32(sbBM);

		DWORD dwWid,dwHei;
		double lfRate;

		if (sbPrev->getWidth()>sbPrev->getHeight()) {

			if (sbPrev->getWidth()>128)
				lfRate=128.0/(double)sbPrev->getWidth();
			else
				lfRate=1;

		} else {

			if (sbPrev->getHeight()>128)
				lfRate=128.0/(double)sbPrev->getHeight();
			else
				lfRate=1;

		}

		dwWid=(DWORD)(sbPrev->getWidth()*lfRate);
		dwHei=(DWORD)(sbPrev->getHeight()*lfRate);

		sbPrev->resize(dwWid,dwHei);
		sbOri=new SDIB32(sbPrev);

		hwEditR=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  28,8,48,22,hwnd,(HMENU)0,hInst,NULL);
		hwUdR=CreateUpDownControl(WS_CHILD|WS_BORDER|WS_VISIBLE|UDS_SETBUDDYINT,
		  76,8,24,22,hwnd,1,hInst,hwEditR,256,2,4);

		hwEditG=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  28,40,48,22,hwnd,(HMENU)2,hInst,NULL);
		hwUdG=CreateUpDownControl(WS_CHILD|WS_BORDER|WS_VISIBLE|UDS_SETBUDDYINT,
		  76,40,24,22,hwnd,3,hInst,hwEditG,256,2,4);

		hwEditB=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  28,72,48,22,hwnd,(HMENU)4,hInst,NULL);
		hwUdB=CreateUpDownControl(WS_CHILD|WS_BORDER|WS_VISIBLE|UDS_SETBUDDYINT,
		  76,72,24,22,hwnd,5,hInst,hwEditB,256,2,4);

		// {^쐬
		hwOK=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  8,100,72,32,hwnd,(HMENU)6,hInst,NULL);
		hwCansel=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  96,100,72,32,hwnd,(HMENU)7,hInst,NULL);

		hwRp1=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_CENTER,
          4,10,22,20,hwnd,(HMENU)8,hInst,NULL);
		SetWindowText(hwRp1,"R");
		hwGp1=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_CENTER,
          4,42,22,20,hwnd,(HMENU)9,hInst,NULL);
		SetWindowText(hwGp1,"G");
		hwBp1=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_CENTER,
          4,74,22,20,hwnd,(HMENU)10,hInst,NULL);
		SetWindowText(hwBp1,"B");
		hwRp2=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_LEFT,
          104,10,40,22,hwnd,(HMENU)11,hInst,NULL);
		SetWindowText(hwRp2,"K");
		hwGp2=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_LEFT,
          104,42,40,22,hwnd,(HMENU)12,hInst,NULL);
		SetWindowText(hwGp2,"K");
		hwBp2=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_LEFT,
          104,74,40,22,hwnd,(HMENU)13,hInst,NULL);
		SetWindowText(hwBp2,"K");

		return 0;

	case WM_COMMAND: // R}hbZ[W

		if (HIWORD(wParam)==EN_CHANGE) {

			GetWindowText(hwEditR,str,16);
			r=atol(str);
			GetWindowText(hwEditG,str,16);
			g=atol(str);
			GetWindowText(hwEditB,str,16);
			b=atol(str);

			*sbPrev=*sbOri;

			saAgent.post(sbPrev,r,g,b);

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow(hwnd);

			break;

		}

		switch (LOWORD(wParam)) {

		case 6: // s{^

			*sbBack=*sbBM;

			GetWindowText(hwEditR,str,16);
			r=atol(str);
			GetWindowText(hwEditG,str,16);
			g=atol(str);
			GetWindowText(hwEditB,str,16);
			b=atol(str);

			saAgent.post(sbBM,r,g,b);

			*lpDone=1;

			DestroyWindow(hwnd);

			break;

		case 7: // {^

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_PAINT:

		hdc=BeginPaint(hwnd,&ps);
		saAgent.draw(sbPrev,hdc,176,8);
		EndPaint(hwnd,&ps);

		return 0;

	case WM_CTLCOLORSTATIC: // x̔wiFݒ

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

		if (*lpDone!=1)
			*lpDone=2;

		delete sbPrev,sbOri;

		break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool outline() { // ֊sǉ_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("COutlineDialog","֊sǉ",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  320,200,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	OutlineDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v

		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK OutlineDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwDisp,hwEditDis,hwUdDis,hwOK,hwCansel;
	static LPDWORD lpDone=NULL;
	I32 dis;
	TCHAR str[16];

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		hwDisp=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_CENTER,
          4,10,60,20,hwnd,(HMENU)0,hInst,NULL);
		SetWindowText(hwDisp,"El");

		hwEditDis=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  72,8,48,22,hwnd,(HMENU)1,hInst,NULL);

		hwUdDis=CreateUpDownControl(WS_CHILD|WS_BORDER|WS_VISIBLE|UDS_SETBUDDYINT,
		  120,8,24,22,hwnd,1,hInst,hwEditDis,256,1,64);

		// {^쐬
		hwOK=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  8,100,72,32,hwnd,(HMENU)3,hInst,NULL);
		hwCansel=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  96,100,72,32,hwnd,(HMENU)4,hInst,NULL);

		return 0;

	case WM_COMMAND: // R}hbZ[W

		switch (LOWORD(wParam)) {

		case 3: // s{^

			GetWindowText(hwEditDis,str,16);
			dis=atol(str);

			if (dis<1) {

				MessageBox(hwnd,"ElłB","G[",MB_OK);

				DestroyWindow(hwnd);

				break;

			}

			*sbBack=*sbBM;

			saAgent.outline(sbBM,dis,0x000000);

			*lpDone=1;

			DestroyWindow(hwnd);

			break;

		case 4: // {^

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_CTLCOLORSTATIC: // x̔wiFݒ

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

		if (*lpDone!=1)
			*lpDone=2;

		break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool aalia() { // A`GCAVO_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("CAaliaDialog","A`GCAVO",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  320,200,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	AaliaDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v

		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK AaliaDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwDisp,hwEditDis,hwUdDis,hwOK,hwCansel;
	static LPDWORD lpDone=NULL;
	I32 dis;
	TCHAR str[16];

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		hwDisp=CreateWindow("STATIC",NULL,WS_CHILD | WS_VISIBLE | SS_CENTER,
          4,10,60,20,hwnd,(HMENU)0,hInst,NULL);
		SetWindowText(hwDisp,"El");

		hwEditDis=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  72,8,48,22,hwnd,(HMENU)1,hInst,NULL);

		hwUdDis=CreateUpDownControl(WS_CHILD|WS_BORDER|WS_VISIBLE|UDS_SETBUDDYINT,
		  120,8,24,22,hwnd,1,hInst,hwEditDis,256,1,128);

		// {^쐬
		hwOK=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  8,100,72,32,hwnd,(HMENU)3,hInst,NULL);
		hwCansel=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  96,100,72,32,hwnd,(HMENU)4,hInst,NULL);

		return 0;

	case WM_COMMAND: // R}hbZ[W

		switch (LOWORD(wParam)) {

		case 3: // s{^

			GetWindowText(hwEditDis,str,16);
			dis=atol(str);

			if (dis<1) {

				MessageBox(hwnd,"ElłB","G[",MB_OK);

				DestroyWindow(hwnd);

				break;

			}

			*sbBack=*sbBM;

			saAgent.aalia(sbBM,dis);

			*lpDone=1;

			DestroyWindow(hwnd);

			break;

		case 4: // {^

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_CTLCOLORSTATIC: // x̔wiFݒ

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

		if (*lpDone!=1)
			*lpDone=2;

		break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool ycut() { // K؎̂ă_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("CYCutDialog","K؎̂",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  360,224,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	YCutDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v

		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK YCutDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwMenu,hwOK,hwPrev,hwCansel;
	static HWND hwEditY,hwUdY,hwEditR,hwEditG,hwEditB;
	static LPDWORD lpDone=NULL;
	int iY,iR,iG,iB,iMode;
	char str[16];
	static SDIB32 *sbPrev,*sbOri;
	HDC hdc;
	PAINTSTRUCT ps;

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		iMode=0;

		CreateWindow("STATIC","El",WS_CHILD|WS_VISIBLE,
		      4,4,128,28,hwnd,(HMENU)1,hInst,NULL);

		hwEditY=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  4,32,48,22,hwnd,(HMENU)2,hInst,NULL);

		hwUdY=CreateUpDownControl(WS_CHILD|WS_BORDER|WS_VISIBLE|UDS_SETBUDDYINT,
		  55,32,24,22,hwnd,1,hInst,hwEditY,255,0,128);

		hwMenu=CreateWindow("COMBOBOX",NULL,WS_CHILD|WS_VISIBLE|CBS_DROPDOWN|WS_TABSTOP,
			  80,32,72,90,hwnd,(HMENU)4,hInst,NULL);
		SendMessage(hwMenu,CB_ADDSTRING,-1,(LPARAM)"ȉ");
		SendMessage(hwMenu,CB_ADDSTRING,-1,(LPARAM)"ȏ");
		SendMessage(hwMenu,CB_SETCURSEL,0,1);

		CreateWindow("STATIC","uF",WS_CHILD|WS_VISIBLE,
		     4,72,128,28,hwnd,(HMENU)5,hInst,NULL);

		CreateWindow("STATIC","R:",WS_CHILD|WS_VISIBLE,
		     4,100,16,24,hwnd,(HMENU)12,hInst,NULL);
		CreateWindow("STATIC","G:",WS_CHILD|WS_VISIBLE,
		     72,100,16,24,hwnd,(HMENU)13,hInst,NULL);
		CreateWindow("STATIC","B:",WS_CHILD|WS_VISIBLE,
		     140,100,16,24,hwnd,(HMENU)14,hInst,NULL);

		hwEditR=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  20,100,48,22,hwnd,(HMENU)6,hInst,NULL);
		hwEditG=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  88,100,48,22,hwnd,(HMENU)7,hInst,NULL);
		hwEditB=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  156,100,48,22,hwnd,(HMENU)8,hInst,NULL);
		
		// {^쐬
		hwPrev=CreateWindow("BUTTON","vr[",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  4,144,108,32,hwnd,(HMENU)9,hInst,NULL);
		hwOK=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  128,144,72,32,hwnd,(HMENU)10,hInst,NULL);
		hwCansel=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  208,144,72,32,hwnd,(HMENU)11,hInst,NULL);


		sbPrev=new SDIB32(sbBM);

		DWORD dwWid,dwHei;
		double lfRate;

		if (sbPrev->getWidth()>sbPrev->getHeight()) {

			if (sbPrev->getWidth()>128)
				lfRate=128.0/(double)sbPrev->getWidth();
			else
				lfRate=1;

		} else {

			if (sbPrev->getHeight()>128)
				lfRate=128.0/(double)sbPrev->getHeight();
			else
				lfRate=1;

		}

		dwWid=(DWORD)(sbPrev->getWidth()*lfRate);
		dwHei=(DWORD)(sbPrev->getHeight()*lfRate);

		sbPrev->resize(dwWid,dwHei);
		sbOri=new SDIB32(sbPrev);

		return 0;

	case WM_COMMAND: // R}hbZ[W

		switch (LOWORD(wParam)) {

		case 9: // vr[{^

			*sbPrev=*sbOri;

			GetWindowText(hwEditY,str,16);
			iY=atol(str);
			GetWindowText(hwEditR,str,16);
			iR=atol(str);
			GetWindowText(hwEditG,str,16);
			iG=atol(str);
			GetWindowText(hwEditB,str,16);
			iB=atol(str);

			if (iR<0 ||iR>255 ||iG<0 ||iG>255 ||iB<0 ||iB>255) {

				MessageBox(hwnd,"uF̐ݒɌ肪܂","G[",MB_OK);

				return 0;

			}

			if (SendMessage(hwMenu,CB_GETCURSEL,0,0)==0)
				saAgent.ycut(sbPrev,1,iY,iR,iG,iB);
			else
				saAgent.ycut(sbPrev,2,iY,iR,iG,iB);

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow(hwnd);

			break;

		case 10: // s{^

			GetWindowText(hwEditY,str,16);
			iY=atol(str);
			GetWindowText(hwEditR,str,16);
			iR=atol(str);
			GetWindowText(hwEditG,str,16);
			iG=atol(str);
			GetWindowText(hwEditB,str,16);
			iB=atol(str);

			if (iR<0 ||iR>255 ||iG<0 ||iG>255 ||iB<0 ||iB>255) {

				MessageBox(hwnd,"uF̐ݒɌ肪܂","G[",MB_OK);

				return 0;

			}

			*sbBack=*sbBM;

			if (SendMessage(hwMenu,CB_GETCURSEL,0,0)==0)
				saAgent.ycut(sbBM,1,iY,iR,iG,iB);
			else
				saAgent.ycut(sbBM,2,iY,iR,iG,iB);

			*lpDone=1;

			DestroyWindow(hwnd);

			break;

		case 11: // {^

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_PAINT:

		hdc=BeginPaint(hwnd,&ps);
		saAgent.draw(sbPrev,hdc,212,4);
		EndPaint(hwnd,&ps);

		return 0;

	case WM_CTLCOLORSTATIC: // x̔wiFݒ

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

			if (*lpDone!=1)
				*lpDone=2;

			delete sbPrev;

			break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool replace() { // PFu_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone=0;

	// _CAO{bNX쐬
	hwDialog=CreateWindow("CReplaceDialog","PFu",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,
	  360,224,NULL,NULL,hInst,NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	ReplaceDialogProc(NULL,(UINT)(&dwDone),0,0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain,FALSE);

	// bZ[W[v
	while (dwDone==0) { // _CAOʂԂ܂Ń[v

		GetMessage(&msg,NULL,0,0);

		if (!IsDialogMessage(hwDialog,&msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// [_
	EnableWindow(hwMain,TRUE);
	BringWindowToTop(hwMain);

	if (dwDone==1)
		return TRUE;
	else
		return FALSE;

}

LRESULT CALLBACK ReplaceDialogProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static HWND hwOK,hwPrev,hwCansel;
	static HWND hwEditR1,hwEditG1,hwEditB1,hwEditR2,hwEditG2,hwEditB2;
	static LPDWORD lpDone=NULL;
	int iR1,iG1,iB1,iR2,iG2,iB2,i,j;
	UI32 u32RGB;
	char str[16];
	static SDIB32 *sbPrev;
	HDC hdc;
	PAINTSTRUCT ps;
	static DWORD dwWid,dwHei;

	if (hwnd==NULL) {

		// ʕϐ̃AhXۑ
		lpDone=(LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		CreateWindow("STATIC","̐F",WS_CHILD|WS_VISIBLE,
		     4,4,128,28,hwnd,(HMENU)10,hInst,NULL);

		CreateWindow("STATIC","R:",WS_CHILD|WS_VISIBLE,
		     4,36,16,24,hwnd,(HMENU)11,hInst,NULL);
		CreateWindow("STATIC","G:",WS_CHILD|WS_VISIBLE,
		     72,36,16,24,hwnd,(HMENU)12,hInst,NULL);
		CreateWindow("STATIC","B:",WS_CHILD|WS_VISIBLE,
		     140,36,16,24,hwnd,(HMENU)13,hInst,NULL);

		hwEditR1=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  20,36,48,22,hwnd,(HMENU)14,hInst,NULL);
		hwEditG1=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  88,36,48,22,hwnd,(HMENU)15,hInst,NULL);
		hwEditB1=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  156,36,48,22,hwnd,(HMENU)16,hInst,NULL);

		CreateWindow("STATIC","ϊF",WS_CHILD|WS_VISIBLE,
		     4,64,128,28,hwnd,(HMENU)17,hInst,NULL);

		CreateWindow("STATIC","R:",WS_CHILD|WS_VISIBLE,
		     4,96,16,24,hwnd,(HMENU)18,hInst,NULL);
		CreateWindow("STATIC","G:",WS_CHILD|WS_VISIBLE,
		     72,96,16,24,hwnd,(HMENU)19,hInst,NULL);
		CreateWindow("STATIC","B:",WS_CHILD|WS_VISIBLE,
		     140,96,16,24,hwnd,(HMENU)20,hInst,NULL);

		hwEditR2=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  20,96,48,22,hwnd,(HMENU)21,hInst,NULL);
		hwEditG2=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  88,96,48,22,hwnd,(HMENU)22,hInst,NULL);
		hwEditB2=CreateWindow("Edit",NULL,WS_CHILD | WS_VISIBLE |WS_BORDER|WS_TABSTOP,
		  156,96,48,22,hwnd,(HMENU)23,hInst,NULL);
		
		// {^쐬
		hwPrev=CreateWindow("BUTTON","vr[",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  4,144,108,32,hwnd,(HMENU)0,hInst,NULL);
		hwOK=CreateWindow("BUTTON","s",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  128,144,72,32,hwnd,(HMENU)1,hInst,NULL);
		hwCansel=CreateWindow("BUTTON","",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  208,144,72,32,hwnd,(HMENU)2,hInst,NULL);

		sbPrev=new SDIB32(sbBM);

		double lfRate;

		if (sbPrev->getWidth()>sbPrev->getHeight()) {

			if (sbPrev->getWidth()>128)
				lfRate=128.0/(double)sbPrev->getWidth();
			else
				lfRate=1;

		} else {

			if (sbPrev->getHeight()>128)
				lfRate=128.0/(double)sbPrev->getHeight();
			else
				lfRate=1;

		}

		dwWid=(DWORD)(sbPrev->getWidth()*lfRate);
		dwHei=(DWORD)(sbPrev->getHeight()*lfRate);

		return 0;

	case WM_COMMAND: // R}hbZ[W

		switch (LOWORD(wParam)) {

		case 0: // vr[{^

			*sbPrev=*sbBM;

			GetWindowText(hwEditR1,str,16);
			if (lstrlen(str)<1)
				iR1=-1;
			else
				iR1=atol(str);

			GetWindowText(hwEditG1,str,16);
			if (lstrlen(str)<1)
				iG1=-1;
			else
				iG1=atol(str);

			GetWindowText(hwEditB1,str,16);
			if (lstrlen(str)<1)
				iB1=-1;
			else
				iB1=atol(str);

			if (iR1<0 ||iR1>255 ||iG1<0 ||iG1>255 ||iB1<0 ||iB1>255) {

				MessageBox(hwnd,"̐F̐ݒɌ肪܂","G[",MB_OK);

				return 0;

			}

			GetWindowText(hwEditR2,str,16);
			if (lstrlen(str)<1)
				iR2=-1;
			else
				iR2=atol(str);

			GetWindowText(hwEditG2,str,16);
			if (lstrlen(str)<1)
				iG2=-1;
			else
				iG2=atol(str);

			GetWindowText(hwEditB2,str,16);
			if (lstrlen(str)<1)
				iB2=-1;
			else
				iB2=atol(str);

			if (iR2<0 ||iR2>255 ||iG2<0 ||iG2>255 ||iB2<0 ||iB2>255) {

				MessageBox(hwnd,"uF̐ݒɌ肪܂","G[",MB_OK);

				return 0;

			}

			u32RGB=(iR2 << 16)+(iG2 <<8)+iB2;

			for (i=0;i<sbPrev->getHeight();i++)
				for (j=0;j<sbPrev->getWidth();j++)
					if (sbPrev->getR(j,i)==iR1 && sbPrev->getG(j,i)==iG1 && sbPrev->getB(j,i)==iB1)
						sbPrev->setRGB(j,i,u32RGB);

			InvalidateRgn(hwnd,NULL,FALSE);
			UpdateWindow(hwnd);

			break;

		case 1: // s{^

			GetWindowText(hwEditR1,str,16);
			if (lstrlen(str)<1)
				iR1=-1;
			else
				iR1=atol(str);

			GetWindowText(hwEditG1,str,16);
			if (lstrlen(str)<1)
				iG1=-1;
			else
				iG1=atol(str);

			GetWindowText(hwEditB1,str,16);
			if (lstrlen(str)<1)
				iB1=-1;
			else
				iB1=atol(str);

			if (iR1<0 ||iR1>255 ||iG1<0 ||iG1>255 ||iB1<0 ||iB1>255) {

				MessageBox(hwnd,"̐F̐ݒɌ肪܂","G[",MB_OK);

				return 0;

			}

			GetWindowText(hwEditR2,str,16);
			if (lstrlen(str)<1)
				iR2=-1;
			else
				iR2=atol(str);

			GetWindowText(hwEditG2,str,16);
			if (lstrlen(str)<1)
				iG2=-1;
			else
				iG2=atol(str);

			GetWindowText(hwEditB2,str,16);
			if (lstrlen(str)<1)
				iB2=-1;
			else
				iB2=atol(str);

			if (iR2<0 ||iR2>255 ||iG2<0 ||iG2>255 ||iB2<0 ||iB2>255) {

				MessageBox(hwnd,"uF̐ݒɌ肪܂","G[",MB_OK);

				return 0;

			}

			*sbBack=*sbBM;

			u32RGB=(iR2 << 16)+(iG2 <<8)+iB2;

			for (i=0;i<sbBM->getHeight();i++)
				for (j=0;j<sbBM->getWidth();j++)
					if (sbBM->getR(j,i)==iR1 && sbBM->getG(j,i)==iG1 && sbBM->getB(j,i)==iB1)
						sbBM->setRGB(j,i,u32RGB);

			*lpDone=1;

			DestroyWindow(hwnd);

			break;

		case 2: // {^

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_PAINT:

		hdc=BeginPaint(hwnd,&ps);

		SetStretchBltMode(hdc,HALFTONE);
		SetBrushOrgEx(hdc,0,0,NULL);
		StretchDIBits(hdc,212,4,dwWid,dwHei,0,0,sbPrev->getWidth(),sbPrev->getHeight(),
		  sbPrev->getPixels(),sbPrev->getInfo(),DIB_RGB_COLORS,SRCCOPY);

		EndPaint(hwnd,&ps);

		return 0;

	case WM_CTLCOLORSTATIC: // x̔wiFݒ

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

			if (*lpDone!=1)
				*lpDone=2;

			delete sbPrev;

			break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool rgbdef() { // Fg_CAO

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone = 0;

	// _CAO{bNX쐬
	hwDialog = CreateWindow("CRGBDefDialog", "Fg",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE,CW_USEDEFAULT, CW_USEDEFAULT,
	  360, 224, NULL, NULL, hInst, NULL);

	// _CAÕEChEvV[W|ɃtOϐ̃AhXn
	RGBDefDialogProc(NULL, (UINT)(&dwDone), 0, 0);

	// CEChE𖳌ă[_
	EnableWindow(hwMain, FALSE);

	// bZ[W[v
	while (dwDone == 0) { // _CAOʂԂ܂Ń[v

		GetMessage(&msg, NULL, 0, 0);

		if (!IsDialogMessage(hwDialog, &msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	// [_
	EnableWindow(hwMain, TRUE);
	BringWindowToTop(hwMain);

	if (dwDone == 1) {
		return true;
	} else {
		return false;
	}

}

LRESULT CALLBACK RGBDefDialogProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	static HWND hwOK, hwCansel, hwC,hwL;
	static LPDWORD lpDone = NULL;
	char str[18];
	int iDC;

	if (hwnd == NULL) {

		// ʕϐ̃AhXۑ
		lpDone = (LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

	case WM_CREATE: // EChE쐬̏

		// {^쐬
		hwOK = CreateWindow("BUTTON", "s", WS_CHILD | WS_VISIBLE,
		  8, 100, 72, 32, hwnd, (HMENU)1, hInst, NULL);

		// {^쐬
		hwCansel = CreateWindow("BUTTON", "", WS_CHILD | WS_VISIBLE,
		  96, 100, 72, 32, hwnd, (HMENU)2, hInst, NULL);

		hwL = CreateWindow("STATIC", ":150%", WS_CHILD | WS_VISIBLE,
		      4, 8, 160, 28, hwnd, (HMENU)2, hInst, NULL);
		hwC = CreateWindow(TRACKBAR_CLASS, NULL, WS_CHILD | WS_VISIBLE,
		      4, 48, 160, 32, hwnd, NULL, hInst, NULL);

		SendMessage(hwC, TBM_SETRANGEMIN, 1, 100);
		SendMessage(hwC, TBM_SETRANGEMAX, 1, 200);
		SendMessage(hwC, TBM_SETPOS, 1, 150);

		return 0;

	case WM_HSCROLL:

		// xɌ݂̒l\
		wsprintf(str, ":%d", SendMessage(hwC, TBM_GETPOS, 0, 0));
		lstrcat(str, "%");

		SetWindowText(hwL, str);

		return 0;

	case WM_COMMAND: // R}hbZ[W

		switch (LOWORD(wParam)) {

		case 1: // s{^

			*sbBack = *sbBM;

			// gbNo[̈ʒug嗦擾
			iDC = SendMessage(hwC,TBM_GETPOS,0,0);

			saAgent.rgbDef(sbBM, (((double)iDC - 100.0) / 100.0));

			// stOZbg
			*lpDone = 1;

			// _CAOj
			DestroyWindow(hwnd);

			break;

		case 2: // {^

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_CTLCOLORSTATIC: // x̔wiFݒ

		return (LRESULT)GetStockObject(WHITE_BRUSH);

	case WM_DESTROY:

		if (*lpDone != 1) {
			*lpDone = 2;
		}

		break;

	}

	return DefWindowProc(hwnd, iMsg, wParam, lParam) ;

}
