//
//   rbg}bvG[WFgNX
//
//       2004/ 9/17 ˁ@P
//
#include <windows.h>
#include "classes.h"
#include <math.h>
#include <stdio.h>

SBMAgent::SBMAgent() {

	fJpg=init();

}

bool SBMAgent::init() {

	// JpegǂݏDLL[h
	hDll=LoadLibrary("jpgr");

	if (hDll == NULL) {
		return false;
	}

	// Jpegǂݏ֐̃AhX擾
	pload = (pLoad)GetProcAddress(hDll, "load");
	psave = (pSave)GetProcAddress(hDll, "save");

	return true;

}

void SBMAgent::draw(SDIB32 *sb, HDC hdc, I32 i32X, I32 i32Y, double lfV) {

	sb->draw(hdc, i32X, i32Y, lfV);

}

bool SBMAgent::loadFile(SDIB32 *sb,LPCTSTR lpszFn) {

	if (strlen(lpszFn)<5)
		return FALSE;

	if (stricmp(lpszFn+(strlen(lpszFn)-4),".jpg")==0)
		return loadJpeg(sb,lpszFn);
	if (stricmp(lpszFn+(strlen(lpszFn)-4),".ycc")==0)
		return loadYCC(sb,lpszFn);
	if (stricmp(lpszFn+(strlen(lpszFn)-4),".wmf")==0)
		return loadWMF(sb,lpszFn);
	else
		return loadBMP(sb,lpszFn);

}

bool SBMAgent::loadBMP(SDIB32 *sb,LPCTSTR lpszFn) {

	I32 i32Width,i32Height,i32L,i,j;
	DWORD offset,dummy;
	HANDLE fh;
	LPBYTE lpWrk,lpBMP;
	LPBITMAPINFO lpInfo;
	BOOL rev=FALSE;

	fh=CreateFile(lpszFn,GENERIC_READ,0,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,NULL);

	lpWrk=(LPBYTE)GlobalAlloc(GPTR,GetFileSize(fh,NULL));

	if (lpWrk==NULL) {

		CloseHandle(fh);
		return FALSE;

	}

	ReadFile(fh,lpWrk,GetFileSize(fh,NULL),&dummy,NULL);

	CloseHandle(fh);

	lpInfo=(LPBITMAPINFO)(lpWrk+sizeof(BITMAPFILEHEADER));

	// sNZ܂ł̃ItZbg擾
	offset=*(LPDWORD)(lpWrk+10);
	lpBMP=lpWrk+offset;

	// QSrbgtJ[rbg}bvłȂΖ
	if (lpWrk[0]!='B' || lpInfo->bmiHeader.biBitCount!=24) {

		GlobalFree(lpWrk);

		return FALSE;

	}

	i32Width=lpInfo->bmiHeader.biWidth;
	i32Height=lpInfo->bmiHeader.biHeight;

	if (i32Height<0) {

		i32Height=-i32Height;
		rev=TRUE;

	}

	sb->reset(i32Width,i32Height);

	if ((i32Width*3) % 4==0) /* obt@̂PC̒vZ */
		i32L=i32Width*3;
	else
		i32L=i32Width*3+(4-(i32Width*3) % 4);

	// BMPsNZRs[
	for (i=0;i<i32Height;i++)
		for (j=0;j<i32Width;j++)
			CopyMemory(sb->getPixels()+j+i*i32Width,lpBMP+j*3+i*i32L,3);

	if (rev)
		upset(sb);

	GlobalFree(lpWrk);

	return TRUE;

}

bool SBMAgent::loadJpeg(SDIB32 *sb,LPCTSTR lpszFn) {

	if (!fJpg)
		return FALSE;

	PUI32 lpWrk;
	I32 i32Width,i32Height;

	lpWrk=pload(lpszFn);

	if (lpWrk==NULL)
		return FALSE;

	i32Width=lpWrk[0];
	i32Height=lpWrk[1];

	sb->reset(i32Width,i32Height);

	for (I32 i=0;i<i32Height;i++)
		for (I32 j=0;j<i32Width;j++)
			CopyMemory(sb->getPixels()+j+i*i32Width,lpWrk+2+j+i*i32Width,3);

	GlobalFree(lpWrk);

	return TRUE;

}

bool SBMAgent::loadYCC(SDIB32 *sb,LPCTSTR lpszFn) {

	I32 i32Width,i32Height,i32Offset,i,j;
	DWORD u32Head,u32Read;
	HANDLE fh;
	LPBYTE lpWrk,lpYCC;

	fh=CreateFile(lpszFn,GENERIC_READ,0,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,NULL);

	lpWrk=(LPBYTE)GlobalAlloc(GPTR,GetFileSize(fh,NULL));

	if (lpWrk==NULL) {

		CloseHandle(fh);
		return FALSE;

	}

	ReadFile(fh,lpWrk,GetFileSize(fh,NULL),&u32Read,NULL);

	CloseHandle(fh);

	if (u32Read<16) {

		GlobalFree(lpWrk);
		return false;

	}

	u32Head=*((PUI32)lpWrk);
	i32Offset=*((PUI32)(lpWrk+4));
	i32Width=*((PUI32)(lpWrk+8));
	i32Height=*((PUI32)(lpWrk+12));
	lpYCC=lpWrk+i32Offset;

	if (u32Head!='Y'+('C' << 8)+(8 << 24)) {

		GlobalFree(lpWrk);
		return false;

	}

	if (u32Read<(UI32)(i32Offset+i32Width*i32Height*3)) {

		GlobalFree(lpWrk);
		return false;

	}

	sb->reset(i32Width,i32Height);

	// YCCt@CYCrCbobt@쐬
	for (i=0;i<i32Height;i++)
		for (j=0;j<i32Width;j++) {

			sb->setBuffer1(j,i32Height-i-1,lpYCC[j*3+i*i32Width*3]);
			sb->setBuffer2(j,i32Height-i-1,lpYCC[j*3+i*i32Width*3+1]);
			sb->setBuffer3(j,i32Height-i-1,lpYCC[j*3+i*i32Width*3+2]);

		}

	// YCrCbobt@sNZ쐬
	sb->setRGBtoPixels();

	GlobalFree(lpWrk);

	return TRUE;

}

bool SBMAgent::loadWMF(SDIB32 *sb, LPCTSTR lpszFn) {

	DWORD dwSize, dwRead;
	HENHMETAFILE hemWMF;
	ENHMETAHEADER emhHeader;
	RECT recWMF;

	HANDLE fh = CreateFile(lpszFn, GENERIC_READ, 0, NULL, OPEN_EXISTING,
	             FILE_ATTRIBUTE_NORMAL, NULL);

	dwSize = GetFileSize(fh, NULL);

	/* t@Cǂݍ݃obt@m */
	LPBYTE lpBuf = (LPBYTE)HeapAlloc(GetProcessHeap(), 0, dwSize);

	ReadFile(fh, lpBuf, dwSize, &dwRead, NULL);

	CloseHandle(fh);

	/* APM`WMFłȂ΃G[ */
	if (*(LPDWORD)lpBuf != 0x9AC6CDD7) {

		HeapFree(GetProcessHeap(), 0, lpBuf);

		return false;

	}

	hemWMF = SetWinMetaFileBits(dwSize - 22, lpBuf + 22, NULL, NULL);

	HeapFree(GetProcessHeap(), 0, lpBuf);

	if (hemWMF == NULL) {
		return false;
	}

	GetEnhMetaFileHeader(hemWMF, sizeof(emhHeader), &emhHeader);

	int iWMFWidth = emhHeader.szlDevice.cx;
	int iWMFHeight = emhHeader.szlDevice.cy;

	if (iWMFWidth * iWMFHeight < 1) {
		return false;
	}

	recWMF.left = 0;
	recWMF.top = 0;
	recWMF.right = iWMFWidth;
	recWMF.bottom = iWMFHeight;

	HDC hdc = GetDC(NULL);

	HBITMAP hbmpImg = CreateCompatibleBitmap(hdc, iWMFWidth, iWMFHeight);

	HDC hdcMem = CreateCompatibleDC(hdc);

	HBITMAP hbmpOld = SelectObject(hdcMem, hbmpImg);

	ReleaseDC(NULL, hdc);

	PlayEnhMetaFile(hdcMem, hemWMF, &recWMF);

	if (!sb->assign(hbmpImg)) {

		SelectObject(hdcMem, hbmpOld);

		DeleteObject(hbmpImg);

		DeleteDC(hdcMem);

		return false;

	}

	SelectObject(hdcMem, hbmpOld);

	DeleteObject(hbmpImg);

	DeleteDC(hdcMem);

	return true;

}

bool SBMAgent::saveFile(SDIB32 *sb,LPCTSTR lpszFn,I32 dwJQU) { // t@Cǂݍ

	if (strlen(lpszFn)<5)
		return FALSE;

	if (stricmp(lpszFn+(strlen(lpszFn)-4),".jpg")==0)
		return saveJpeg(sb,lpszFn,dwJQU);
	else if (stricmp(lpszFn+(strlen(lpszFn)-4),".ycc")==0)
		return saveYCC(sb,lpszFn);
	else
		return saveBMP(sb,lpszFn);

}

bool SBMAgent::saveBMP(SDIB32 *sb,LPCTSTR lpszFn) { // BMPɕۑ

	UI32 u32Size;
	I32 i,j,i32FSize,i32Width,i32Height,i32L;
	HANDLE fh;
	LPBITMAPFILEHEADER lpHead;
	LPBITMAPINFOHEADER lpInfo;
	LPBYTE lpBuf,lpPixel;

	i32Width=sb->getWidth();
	i32Height=sb->getHeight();

	if ((i32Width*3) % 4==0) // obt@̂PC̒vZ
		i32L=i32Width*3;
	else
		i32L=i32Width*3+(4-(i32Width*3) % 4);

	// ݗpobt@̃TCYvZ
	i32FSize=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+i32L*i32Height;

	// obt@mۂƃ|C^ݒ
	lpBuf=(PUI8)GlobalAlloc(GPTR,i32FSize);
	lpHead=(LPBITMAPFILEHEADER)lpBuf;
	lpInfo=(LPBITMAPINFOHEADER)(lpBuf+sizeof(BITMAPFILEHEADER));
	lpPixel=lpBuf+sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);

	// 24rbgBMPt@C̃wb_쐬
	lpHead->bfType='M'*256+'B';
	lpHead->bfSize=i32FSize;
	lpHead->bfOffBits=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);
	lpInfo->biSize=sizeof(BITMAPINFOHEADER);
	lpInfo->biWidth=i32Width;
	lpInfo->biHeight=i32Height;
	lpInfo->biPlanes=1;
	lpInfo->biBitCount=24;

	for (i=0;i<i32Height;i++) // sNZobt@ɃRs[
		for (j=0;j<i32Width;j++)
			CopyMemory(lpPixel+i*i32L+j*3,sb->getPixels()+i*i32Width+j,3);

	// obt@t@Cɏo
	fh=CreateFile(lpszFn,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	WriteFile(fh,lpBuf,i32FSize,&u32Size,NULL);

	CloseHandle(fh);
	GlobalFree(lpBuf);

	if ((I32)u32Size<i32FSize)
		return false;

	return true;

}

bool SBMAgent::saveJpeg(SDIB32 *sb,LPCTSTR lpszFn,I32 i32JQU) {

	if (!fJpg)
		return FALSE;

	I32 i32Width=sb->getWidth(),i32Height=sb->getHeight();

	PUI32 lpWrk=(PUI32)GlobalAlloc(GPTR,i32Width*i32Height*4+8);

	lpWrk[0]=i32Width;
	lpWrk[1]=i32Height;

	CopyMemory(lpWrk+2,sb->getPixels(),i32Width*i32Height*4);

	UI32 u32Res=psave(lpszFn,lpWrk,i32JQU);

	GlobalFree(lpWrk);

	if (u32Res==0)
		return FALSE;
	else
		return TRUE;

}

bool SBMAgent::saveYCC(SDIB32 *sb,LPCTSTR lpszFn) { // YCrCbۑ

	UI32 u32Size;
	I32 i,j,i32FSize,i32Width,i32Height,i32Offset;
	HANDLE fh;
	LPBYTE lpBuf,lpPixel;
	bool bUpset=false;

	if (sb==NULL)
		return false;

	i32Width=sb->getWidth();
	i32Height=sb->getHeight();
	if (i32Height<0) {

		i32Height=-i32Height;
		bUpset=true;
		
	}

	i32Offset=16;

	// ݗpobt@̃TCYvZ
	i32FSize=i32Offset+i32Width*i32Height*3;

	// obt@mۂƃ|C^ݒ
	lpBuf=(PUI8)GlobalAlloc(GPTR,i32FSize);
	if (lpBuf==NULL)
		return false;

	lpPixel=lpBuf+i32Offset;

	lpBuf[0]='Y';
	lpBuf[1]='C';
	lpBuf[2]=0;
	lpBuf[3]=8;
	CopyMemory(lpBuf+4,&i32Offset,4);
	CopyMemory(lpBuf+8,&i32Width,4);
	CopyMemory(lpBuf+12,&i32Height,4);

	// YcrCbobt@쐬
	sb->setYUVtoBuffer();

	// YCrCbobt@opobt@ɃRs[
	for (i=0;i<i32Height;i++)
		for (j=0;j<i32Width;j++) {

			if (bUpset) {

				lpPixel[j*3+i32Width*3*i]=sb->getBuffer1(j,i);
				lpPixel[j*3+i32Width*3*i+1]=sb->getBuffer2(j,i);
				lpPixel[j*3+i32Width*3*i+2]=sb->getBuffer3(j,i);

			} else {

				lpPixel[j*3+i32Width*3*i]=sb->getBuffer1(j,i32Height-i-1);
				lpPixel[j*3+i32Width*3*i+1]=sb->getBuffer2(j,i32Height-i-1);
				lpPixel[j*3+i32Width*3*i+2]=sb->getBuffer3(j,i32Height-i-1);

			}

		}

	// obt@t@Cɏo
	fh=CreateFile(lpszFn,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	WriteFile(fh,lpBuf,i32FSize,&u32Size,NULL);

	CloseHandle(fh);
	GlobalFree(lpBuf);

	if ((I32)u32Size<i32FSize)
		return false;

	return true;

}

void SBMAgent::xorRGB(SDIB32 *sb) { // F]
	
	I32 i32Width=sb->getWidth(),i32Height=sb->getHeight();

	for (I32 i=0;i<i32Height;i++)
		for (I32 j=0;j<i32Width;j++)
			sb->setRGB(j,i,(sb->getRGB(j,i) ^ 0x00ffffff));

}

void SBMAgent::transR(SDIB32 *sb,I32 i32V) {

	I32 i32Width=sb->getWidth(),i32Height=sb->getHeight();

	for (I32 i=0;i<i32Height;i++)
		for (I32 j=0;j<i32Width;j++)
			sb->setR(j,i,sb->getR(j,i)+i32V);

}

void SBMAgent::transG(SDIB32 *sb,I32 i32V) {

	I32 i32Width=sb->getWidth(),i32Height=sb->getHeight();

	for (I32 i=0;i<i32Height;i++)
		for (I32 j=0;j<i32Width;j++)
			sb->setG(j,i,sb->getG(j,i)+i32V);

}

void SBMAgent::transB(SDIB32 *sb,I32 i32V) {

	I32 i32Width=sb->getWidth(),i32Height=sb->getHeight();

	for (I32 i=0;i<i32Height;i++)
		for (I32 j=0;j<i32Width;j++)
			sb->setB(j,i,sb->getB(j,i)+i32V);

}

void SBMAgent::transY(SDIB32 *sb,I32 i32V) {

	I32 i32Width=sb->getWidth(),i32Height=sb->getHeight();

	for (I32 i=0;i<i32Height;i++)
		for (I32 j=0;j<i32Width;j++)
			sb->setBuffer1(j,i,sb->getBuffer1(j,i)+i32V);

}

void SBMAgent::transU(SDIB32 *sb,I32 i32V) {

	I32 i32Width=sb->getWidth(),i32Height=sb->getHeight();

	for (I32 i=0;i<i32Height;i++)
		for (I32 j=0;j<i32Width;j++)
			sb->setBuffer2(j,i,sb->getBuffer2(j,i)+i32V);

}

void SBMAgent::transV(SDIB32 *sb,I32 i32V) {

	I32 i32Width=sb->getWidth(),i32Height=sb->getHeight();

	for (I32 i=0;i<i32Height;i++)
		for (I32 j=0;j<i32Width;j++)
			sb->setBuffer3(j,i,sb->getBuffer3(j,i)+i32V);

}

void SBMAgent::toGray(SDIB32 *sb) {

	I32 i32Width=sb->getWidth(),i32Height=sb->getHeight();
	UI8 u8Y;

	for (I32 i=0;i<i32Height;i++)
		for (I32 j=0;j<i32Width;j++) {

			u8Y=sb->getY(j,i);

			sb->setR(j,i,u8Y);
			sb->setG(j,i,u8Y);
			sb->setB(j,i,u8Y);

		}

}

void SBMAgent::unsharp(SDIB32 *sb,I32 i32V,double lfV) {

	sb->unsharp(i32V,lfV);

}

bool SBMAgent::calcRGB(SDIB32 *sb,RGBINFO *info) {

	I32 i,j,r,g,b,ro,go,bo;
	I32 i32Width=sb->getWidth(),i32Height=sb->getHeight();

	for(i=0;i<i32Height;i++)
		for(j=0;j<i32Width;j++) {

			ro=sb->getR(j,i);
			go=sb->getG(j,i);
			bo=sb->getB(j,i);

			r=(I32)(ro*info->lfParam[0]+go*info->lfParam[1]+bo*info->lfParam[2]+info->lfParam[3]);
			g=(I32)(ro*info->lfParam[4]+go*info->lfParam[5]+bo*info->lfParam[6]+info->lfParam[7]);
			b=(I32)(ro*info->lfParam[8]+go*info->lfParam[9]+bo*info->lfParam[10]+info->lfParam[11]);

			sb->setR(j,i,r);
			sb->setG(j,i,g);
			sb->setB(j,i,b);

		}

	return TRUE;

}

void SBMAgent::copy(SDIB32 *sb) { // DIBNbv{[hɃRs[

	I32 i, j, i32Width = sb->getWidth(), i32Height = sb->getHeight(), i32L;
	LPBITMAPINFOHEADER lpInfo;
	LPBYTE lpPixel;
	HGLOBAL hMem;
	PUI8 lpMem;

	if ((i32Width * 3) % 4 == 0) { // obt@̂PC̒vZ
		i32L = i32Width * 3;
	} else {
		i32L = i32Width * 3 + (4 - (i32Width * 3) % 4);
	}

	// obt@p̃ubNm
	hMem = GlobalAlloc(GHND, sizeof(BITMAPINFOHEADER) + i32L * i32Height);

	// IuWFNgbNăAhX擾
	lpMem = (LPBYTE)GlobalLock(hMem);

	lpInfo = (LPBITMAPINFOHEADER)lpMem;
	lpPixel = lpMem + sizeof(BITMAPINFOHEADER);
	ZeroMemory(lpInfo, sizeof(BITMAPINFOHEADER));

	// 24rbgDIBwb_쐬
	lpInfo->biSize = sizeof(BITMAPINFOHEADER);
	lpInfo->biWidth = i32Width;
	lpInfo->biHeight = i32Height;
	lpInfo->biPlanes = 1;
	lpInfo->biBitCount = 24;

	for (i = 0;i < i32Height;i++) // sNZobt@ɃRs[
		for (j = 0;j < i32Width;j++)
			CopyMemory(lpPixel + i * i32L + j * 3, sb->getPixels() + i * i32Width + j, 3);

	// obt@AbN
	GlobalUnlock(hMem);

	// Nbv{[hI[vNA
	OpenClipboard(NULL);
	EmptyClipboard();

	// Nbv{[hɃobt@̓eRs[
	SetClipboardData(CF_DIB, hMem);

	// Nbv{[hN[Y
	CloseClipboard();

}

bool SBMAgent::paste(SDIB32 *sb) { // Nbv{[h\t

	if (!OpenClipboard(NULL)) {
		return false;
	}

	HANDLE hMem = GetClipboardData(CF_DIB);

	if (hMem == NULL || GlobalSize(hMem) < sizeof(BITMAPINFOHEADER)) {

		if (hMem != NULL) {
			GlobalUnlock(hMem);
		}

		CloseClipboard();
	
		return false;

	}

	PUI8 lpBuf = (PUI8)GlobalLock(hMem);
	LPBITMAPINFOHEADER lpBM = (LPBITMAPINFOHEADER)lpBuf;

	if (lpBM->biBitCount != 24) {

		GlobalUnlock(hMem);
		CloseClipboard();

		return false;

	}

	PUI8 lpBMP = lpBuf + lpBM->biSize;
	
	I32 i32Width = lpBM->biWidth, i32Height = lpBM->biHeight;
	I32 i32L;

	if ((i32Width) % 4==0) { // obt@̂PC̒vZ
		i32L = i32Width * 3;
	} else {
		i32L = i32Width * 3 + (4 - (i32Width * 3) % 4);
	}

	if (GlobalSize(hMem) < i32L * i32Height + lpBM->biSize) {

		GlobalUnlock(hMem);
		CloseClipboard();

		return false;

	}

	sb->reset(i32Width, i32Height);

	for (I32 i = 0;i < i32Height;i++) // sNZobt@ɃRs[
		for (I32 j = 0;j < i32Width;j++)
			CopyMemory(sb->getPixels() + i * i32Width + j, lpBMP + i * i32L + j * 3, 3);

	GlobalUnlock(hMem);
	CloseClipboard();

	return true;

}

bool SBMAgent::contY(SDIB32 *sb, I32 i32Min1, I32 i32Max1, I32 i32Min2, I32 i32Max2) {

	if (sb == NULL || i32Min1 >= i32Max1 || i32Min2 > i32Max2) {
		return false;
	}

	I32 i, j, i32Width = sb->getWidth(), i32Height = sb->getHeight();
	
	SDIB32 sbTmp = *sb;

	double lfA = (double)(i32Max2 - i32Min2) / (double)(i32Max1 - i32Min1), y;

	sbTmp.setYUVtoBuffer();

	for (i = 0;i < i32Height;i++)
		for (j = 0;j < i32Width;j++) {

			y = (sbTmp.getBuffer1(j, i) - i32Min1) * lfA + i32Min2;
			sbTmp.setBuffer1(j, i, (I32)y);

		}

	sbTmp.setRGBtoPixels();
	sb->setRGB(&sbTmp);

	return true;

}

bool SBMAgent::contS(SDIB32 *sb,I32 i32Ds) {

	I32 i, j, i32Width = sb->getWidth(), i32Height = sb->getHeight();
	double u, v, d, s;
	SDIB32 sbTmp = *sb;

	sbTmp.setYUVtoBuffer();

	for (i = 0;i < i32Height;i++)
		for (j = 0;j < i32Width;j++) {

			u = sbTmp.getBuffer2(j, i) - 128;
			v = sbTmp.getBuffer3(j, i) - 128;
			d = sqrt(u * u + v * v);

			if (d >= 1) {

				s = acos(u / d);
	
				if (v < 0)
					s = 2 * 3.14159 - s;

				d += i32Ds;

			}

			if (d < 1) {

				sbTmp.setBuffer2(j, i, 128);
				sbTmp.setBuffer3(j, i, 128);

			} else {

				u = (d * cos(s)) + 128;
				v = (d * sin(s)) + 128;

				sbTmp.setBuffer2(j, i, (I32)u);
				sbTmp.setBuffer3(j, i, (I32)v);

			}

		}

	sbTmp.setRGBtoPixels();

	sb->setRGB(&sbTmp);

	return true;

}

void SBMAgent::Filter9(SDIB32 *sb, FILTER9INFO *f9Info) {

	sb->Filter9(f9Info);

}

void SBMAgent::upset(SDIB32 *sb) {

	SDIB32 sbTmp = *sb;

	for (I32 i = 0;i < sb->getHeight();i++)
		for (I32 j = 0;j < sb->getWidth();j++)
			sb->setRGB(j, sb->getHeight() - i - 1, sbTmp.getRGB(j, i));

}

void SBMAgent::mirror(SDIB32 *sb) {

	SDIB32 sbTmp = *sb;

	for (I32 i = 0;i < sb->getHeight();i++)
		for (I32 j = 0;j < sb->getWidth();j++)
			sb->setRGB(sb->getWidth() - j - 1, i, sbTmp.getRGB(j, i));

}

void SBMAgent::exchangeXY(SDIB32 *sb) {

	SDIB32 sbTmp = *sb;
	I32 i32Height = sb->getWidth(), i32Width = sb->getHeight();

	sb->reset(i32Width, i32Height);

	for (I32 i = 0;i < i32Height;i++)
		for (I32 j = 0;j < i32Width;j++)
			sb->setRGB(j, i, sbTmp.getRGB(i, j));

}

bool SBMAgent::gamma(SDIB32 *sb, double lfG) {

	I32 i32Width = sb->getWidth(), i32Height = sb->getHeight();
	double r, g, b;

	for (I32 i = 0;i < i32Height;i++)
		for (I32 j = 0;j < i32Width;j++) {

			r = sb->getR(j, i);
			g = sb->getG(j, i);
			b = sb->getB(j, i);

			r = 255 * pow((r / 255.0), (1.0 / lfG));
			g = 255 * pow((g / 255.0), (1.0 / lfG));
			b = 255 * pow((b / 255.0), (1.0 / lfG));

			sb->setR(j, i, (I32)r);
			sb->setG(j, i, (I32)g);
			sb->setB(j, i, (I32)b);

		}

	return true;

}

bool SBMAgent::post(SDIB32 *sb,I32 i32Rs,I32 i32Gs,I32 i32Bs) {

	I32 i, j, i32Width = sb->getWidth(), i32Height = sb->getHeight();
	UI8	rb[256], gb[256], bb[256];

	double d, n;

	if (i32Rs < 2 || i32Rs > 256 || i32Gs < 2 || i32Gs > 256 || i32Bs < 2 || i32Bs > 256) {
		return false;
	}

	/* ԊK̃e[u쐬 */
	n = (256.0 / (double)i32Rs); /* PKɊ܂܂錳̊K */
	d = 255.0 / (double)((double)i32Rs - 1.0); /* PK̑ */

	for (i = 0;i < i32Rs;i++)
		for (j = (int)floor(i * n);j < (int)floor((i + 1) * n);j++)
			rb[j] = (BYTE)(d * i);

	/* ΊK̃e[u쐬 */
	n = (256.0 / (double)i32Gs);
	d = 255.0 / (double)((double)i32Gs - 1.0);

	for (i = 0;i < i32Gs;i++)
		for (j = (int)floor(i * n);j < (int)floor((i + 1) * n);j++)
			gb[j] = (BYTE)(d * i);

	/* K̃e[u쐬 */
	n = (256.0 / (double)i32Bs);
	d = 255.0 / (double)((double)i32Bs - 1.0);

	for (i = 0;i < i32Bs;i++)
		for (j = (int)floor(i * n);j < (int)floor((i + 1) * n);j++)
			bb[j] = (BYTE)(d * i);

	/* esNZRGBϊ */
	for (i = 0;i < i32Height;i++)
		for (j = 0;j < i32Width;j++) {

			sb->setR(j, i, rb[sb->getR(j, i)]);
			sb->setG(j, i, gb[sb->getG(j, i)]);
			sb->setB(j, i, bb[sb->getB(j, i)]);

		}

	return true;

}

I32 SBMAgent::distance(UI32 ui32RGB1, UI32 ui32RGB2) {

	I32 r, g, b, r2, g2, b2;

	r = (ui32RGB1 & 0x00ff0000) >> 16;
	g = (ui32RGB1 & 0x0000ff00) >> 8;
	b = ui32RGB1 & 0x000000ff;

	r2 = (ui32RGB2 & 0x00ff0000) >> 16;
	g2 = (ui32RGB2 & 0x0000ff00) >> 8;
	b2 = ui32RGB2 & 0x000000ff;

	return (r - r2) * (r - r2) + (g - g2) * (g - g2) + (b - b2) * (b - b2);

}

bool SBMAgent::outline(SDIB32 *sb, I32 i32Dist, UI32 ui32Color) {

	I32 i, j, i32Width = sb->getWidth(), i32Height = sb->getHeight(), i32Dis, i32Max;
	SDIB32 sbTmp = *sb;

	for (i = 0;i < i32Height;i++)
		for (j = 0;j < i32Width;j++) {

			i32Dis = 0;

			if (j >= 1)
				i32Dis = distance(sb->getRGB(j, i), sb->getRGB(j - 1, i));

			i32Max = i32Dis;

			if (j < i32Width - 1) {
				i32Dis = distance(sb->getRGB(j, i), sb->getRGB(j + 1, i));
			}

			if (i32Dis > i32Max) {
				i32Max = i32Dis;
			}

			if (i >= 1) {
				i32Dis = distance(sb->getRGB(j, i), sb->getRGB(j, i - 1));
			}

			if (i32Dis > i32Max) {
				i32Max = i32Dis;
			}

			if (i < i32Height - 1) {
				i32Dis = distance(sb->getRGB(j, i), sb->getRGB(j, i + 1));
			}

			if (i32Dis > i32Max) {
				i32Max = i32Dis;
			}

			if (i32Max > i32Dist * i32Dist) {
				sbTmp.setRGB(j, i, ui32Color);
			}

		}

	for (i = 0;i < sb->getHeight();i++)
		for (j = 0;j < sb->getWidth();j++)
			sb->setRGB(j, i, sbTmp.getRGB(j, i));

	return true;

}

bool SBMAgent::outline2(SDIB32 *sb, I32 i32Dist, UI32 ui32Color, UI32 ui32Color2) {

	I32 i, j, i32Width = sb->getWidth(), i32Height = sb->getHeight(), i32Dis, i32Max;
	SDIB32 sbTmp = *sb, sbWrk = *sb;

	for (i = 0;i < i32Height;i++)
		for (j = 0;j < i32Width;j++) {

			i32Dis = 0;

			if (j >= 1) {
				i32Dis = distance(sbTmp.getRGB(j, i), sbTmp.getRGB(j - 1, i));
			}

			i32Max = i32Dis;

			if (j < i32Width - 1) {
				i32Dis = distance(sbTmp.getRGB(j, i), sbTmp.getRGB(j + 1, i));
			}

			if (i32Dis > i32Max) {
				i32Max = i32Dis;
			}

			if (i >= 1) {
				i32Dis = distance(sbTmp.getRGB(j, i), sbTmp.getRGB(j, i - 1));
			}

			if (i32Dis > i32Max) {
				i32Max = i32Dis;
			}

			if (i < i32Height - 1) {
				i32Dis = distance(sbTmp.getRGB(j, i), sbTmp.getRGB(j, i + 1));
			}

			if (i32Dis > i32Max) {
				i32Max = i32Dis;
			}

			if (i32Max > i32Dist * i32Dist) {
				sbWrk.setRGB(j, i, ui32Color);
			} else {
				sbWrk.setRGB(j, i, ui32Color2);
			}

		}

	for (i = 0;i < sb->getHeight();i++)
		for (j = 0;j < sb->getWidth();j++)
			sb->setRGB(j, i, sbWrk.getRGB(j, i));

	return true;

}

bool SBMAgent::aalia(SDIB32 *sb, I32 i32Dist) {

	I32 i, j, k, l, i32Width = sb->getWidth(), i32Height = sb->getHeight();
	SDIB32 sbTmp = *sb;
	bool done;
	i32Dist *= i32Dist;

	for (i = 0;i < i32Height;i++)
		for (j = 0;j < i32Width;j++) {

			done = false;

			for (k = -1;k <= 1 && !done;k++)
				for (l = -1;l <= 1 && !done;l++)
					if (j + l >= 0 && j + l < i32Width && i + k >= 0 && i + k < i32Height && !(k == 0 && l == 0) &&
						distance(sb->getRGB(j + l, i + k), sb->getRGB(j, i)) > i32Dist) {

						sbTmp.mix(j, i, 1);
						done = true;

					}

			}

	for (i = 0;i < sb->getHeight();i++)
		for (j = 0;j < sb->getWidth();j++)
			sb->setRGB(j, i, sbTmp.getRGB(j, i));

	return true;

}

bool SBMAgent::ycut(SDIB32 *sb, I32 i32Arg1, I32 i32Arg2, I32 i32Arg3, I32 i32Arg4, I32 i32Arg5) {

	if (!(i32Arg1 == 1 || i32Arg1 == 2)) {
		return false;
	}

	I32 i, j, i32Width = sb->getWidth(), i32Height = sb->getHeight();

	sb->setYUVtoBuffer();

	for (i = 0;i < i32Height;i++)
		for (j = 0;j < i32Width;j++) {

			if (i32Arg1 == 1 && sb->getBuffer1(j, i) <= i32Arg2) {

				sb->setR(j, i, i32Arg3);
				sb->setG(j, i, i32Arg4);
				sb->setB(j, i, i32Arg5);

			}

			if (i32Arg1 == 2 && sb->getBuffer1(j, i) >= i32Arg2) {

				sb->setR(j, i, i32Arg3);
				sb->setG(j, i, i32Arg4);
				sb->setB(j, i, i32Arg5);

			}

		}

	return true;

}

bool SBMAgent::rgbDef(SDIB32 *sb, double lfRate) { // Fg

	if (lfRate == 0.0) { // ύXȂ
		return true;
	}

	I32 i32Width = sb->getWidth(), i32Height = sb->getHeight();
	int iAvR, iAvG, iAvB, iPixR, iPixG, iPixB, n;

	SDIB32 sbTmp = *sb; // ȌԂۑ

	for (int i = 0;i < i32Height;i++)
		for (int j = 0;j < i32Width;j++) {

			iAvR = 0;
			iAvG = 0;
			iAvB = 0;
			n = 0;

			if (j > 0) { /* ̃sNZ̐ */

				iAvR += sbTmp.getR(j - 1, i);
				iAvG += sbTmp.getG(j - 1, i);
				iAvB += sbTmp.getB(j - 1, i);

				n++;

			}

			if (i > 0) { /* ̃sNZ̐ */

				iAvR += sbTmp.getR(j, i - 1);
				iAvG += sbTmp.getG(j, i - 1);
				iAvB += sbTmp.getB(j, i - 1);

				n++;

			}

			if (j < i32Width - 1)  {/* ẼsNZ̐ */

				iAvR += sbTmp.getR(j + 1, i);
				iAvG += sbTmp.getG(j + 1, i);
				iAvB += sbTmp.getB(j + 1, i);

				n++;

			}

			if (i < i32Height - 1) { /* ̃sNZ̐ */

				iAvR += sbTmp.getR(j, i + 1);
				iAvG += sbTmp.getG(j, i + 1);
				iAvB += sbTmp.getB(j, i + 1);

				n++;

			}

			/* ӃsNZ̐F̕όvZ */
			iAvR = (int)(iAvR / n);
			iAvG = (int)(iAvG / n);
			iAvB = (int)(iAvB / n);

			/* ΏۃsNZ̐F擾 */
			iPixR = sbTmp.getR(j, i);
			iPixG = sbTmp.getG(j, i);
			iPixB = sbTmp.getB(j, i);

			iPixR += (int)((iPixR - iAvR) * lfRate);
			iPixG += (int)((iPixG - iAvG) * lfRate);
			iPixB += (int)((iPixB - iAvB) * lfRate);

			/* ΏۃsNZƎӃsNZ̐Fg */
			sb->setR(j, i, iPixR);
			sb->setG(j, i, iPixG);
			sb->setB(j, i, iPixB);

		}

	return true;

}

void SBMAgent::t216(SDIB32 *sb) {

	I32 i32Width = sb->getWidth(), i32Height = sb->getHeight();

	for (I32 i = 0;i < i32Height;i++) {
		for (I32 j = 0;j < i32Width;j++) {

			int r = sb->getR(j, i);
			int g = sb->getG(j, i);
			int b = sb->getB(j, i);

			r = 51 * (int)(((double)r / 51.0) + 0.5);
			g = 51 * (int)(((double)g / 51.0) + 0.5);
			b = 51 * (int)(((double)b / 51.0) + 0.5);

			sb->setR(j, i, r);
			sb->setG(j, i, g);
			sb->setB(j, i, b);

		}
	}

}

SBMAgent::~SBMAgent() {

	FreeLibrary(hDll);

}
